/* A Bison parser, made by GNU Bison 2.4.2.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2006, 2009-2010 Free Software
   Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 2 "grap.yy"

/* This code is (c) 1998-2001 Ted Faber (faber@lunabase.org) see the
   COPYRIGHT file for the full copyright and limitations of
   liabilities. */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>
#include <iostream>
#include <stack>
#include <math.h>
#ifdef STDC_HEADERS
#include <limits.h>
#else
// Best guess, really - limits should exist
#ifndef LONG_MAX
#define LONG_MAX        0x7fffffffL
#endif
#endif
#if defined(STDC_HEADERS) | defined(HAVE_STDLIB_H)
#include <stdlib.h>
#endif
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif

#include <time.h>

#ifdef __MINGW32__
char * strptime(const char*, const char*, struct tm*);
#endif

#include "grap.h"
#include "grap_data.h"
#include "grap_draw.h"

doubleDictionary vars;
graph *the_graph =0;
lexStack lexstack;
macroDictionary macros;
stringSequence path;
bool first_line;
bool unaligned_default = false;	// Should strings be unaligned by default 
bool clip_default = true;	// Should strings be clipped by default 
extern bool do_sprintf;		// true if it's acceptable to parse sprintf

line* defline;
coord *defcoord;
string *graph_name;
string *graph_pos;
string *ps_param;
// number of lines in a number list (used in grap_parse.cc) 
int nlines;

// bison wants these defined....
int yyerror(const char*);
int yylex();
void init_dict(); 

// defined in grap_lex.l
extern bool include_file(string *, bool =false, bool=true);
extern void lex_no_macro_expansion(); 
extern void lex_macro_expansion_ok(); 
extern void lex_begin_macro_text(); 
extern void lex_begin_rest_of_line();
extern void lex_no_coord();
extern void lex_coord_ok();
extern void lex_begin_copy( string*s=0);
extern int include_string(string *, for_descriptor *f=0,
			  grap_input i=GMACRO);
extern void lex_hunt_macro();
extern int yyparse(void);	// To shut yacc (vs. bison) up.
void draw_graph();
void init_graph();

// Parsing utilities in grap_parse.cc.  Locating them there reduces
// compilation time (this file was getting very large) and eliminates
// some code redundancy.
extern graph *initial_graph(); 
extern linedesc* combine_linedesc(linedesc *, linedesc*);
extern axis combine_logs(axis, axis);
extern void draw_statement(string *, linedesc *, DisplayString *);
extern void num_list(doublelist *);
extern double assignment_statement(string *, double);
extern stringlist *combine_strings(stringlist *, string *, strmod &);
extern void plot_statement(double, DisplayString *, point *); 
extern void next_statement(string *, point *, linedesc *);
extern ticklist *ticklist_elem(double, DisplayString *, ticklist *);
extern ticklist *tick_for(coord *, double, double, bydesc, DisplayString *);
extern void ticks_statement(sides, double, shiftlist *, ticklist *);
extern void grid_statement(sides, int, linedesc *, shiftlist *, ticklist *);
extern void line_statement(int, linedesc *, point *, point *, linedesc *);
extern axisdesc axis_description(axis, double, double );
extern void coord_statement(string *, axisdesc&, axisdesc&, axis);
extern void coord_statement(coord *, axisdesc&, axisdesc&, axis);
extern void for_statement(string *, double, double, bydesc, string *);
extern void process_frame(linedesc *, frame *, frame *);
extern void define_macro(string *, string*);
extern void bar_statement(coord *, sides, double, double, double,
		   double, linedesc *); 
// adapters to return complex (complex-ish) functions
void grap_srandom(double x) { srandom(static_cast<unsigned int>(x)); }
double grap_random() {
    return static_cast<double>(random())/(static_cast<double>(LONG_MAX)+1e-6);
}
double grap_getpid() { return static_cast<double>(getpid());} 
double pow10(double x) { return pow(10,x); }
double toint(double x) { return static_cast<double>(int(x)); }
double grap_min(double a, double b) { return (a<b) ? a : b; } 
double grap_max(double a, double b) { return (a>b) ? a : b; } 
 
typedef void (*vfunction1)(double);
typedef double (*function0)();
typedef double (*function1)(double);
typedef double (*function2)(double, double);
// jump tables for dispatching internal functions
vfunction1 jtvf1[NVF1] = { grap_srandom };
function0 jtf0[NF0] = { grap_random, grap_getpid };
function1 jtf1[NF1] = { log10, pow10, toint, sin, cos, sqrt, exp, log, floor,
	ceil };
function2 jtf2[NF2] = { atan2, grap_min, grap_max};


/* Line 189 of yacc.c  */
#line 196 "grap.cc"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMBER = 258,
     START = 259,
     END = 260,
     IDENT = 261,
     COPY = 262,
     SEP = 263,
     STRING = 264,
     COORD_NAME = 265,
     UNDEFINE = 266,
     SOLID = 267,
     INVIS = 268,
     DOTTED = 269,
     DASHED = 270,
     DRAW = 271,
     LPAREN = 272,
     RPAREN = 273,
     FUNC0 = 274,
     FUNC1 = 275,
     FUNC2 = 276,
     COMMA = 277,
     LINE = 278,
     PLOT = 279,
     FROM = 280,
     TO = 281,
     AT = 282,
     NEXT = 283,
     FRAME = 284,
     LEFT = 285,
     RIGHT = 286,
     TOP = 287,
     BOTTOM = 288,
     UP = 289,
     DOWN = 290,
     HT = 291,
     WID = 292,
     IN = 293,
     OUT = 294,
     NONE = 295,
     TICKS = 296,
     OFF = 297,
     BY = 298,
     GRID = 299,
     LJUST = 300,
     RJUST = 301,
     ABOVE = 302,
     BELOW = 303,
     ALIGNED = 304,
     PLUS = 305,
     MINUS = 306,
     TIMES = 307,
     DIV = 308,
     CARAT = 309,
     EQUALS = 310,
     SIZE = 311,
     UNALIGNED = 312,
     LABEL = 313,
     RADIUS = 314,
     CIRCLE = 315,
     ARROW = 316,
     XDIM = 317,
     YDIM = 318,
     LOG_X = 319,
     LOG_Y = 320,
     LOG_LOG = 321,
     COORD = 322,
     TEXT = 323,
     DEFINE = 324,
     IF = 325,
     THEN = 326,
     ELSE = 327,
     EQ = 328,
     NEQ = 329,
     LT = 330,
     GT = 331,
     LTE = 332,
     GTE = 333,
     NOT = 334,
     OR = 335,
     AND = 336,
     FOR = 337,
     DO = 338,
     MACRO = 339,
     COPYTEXT = 340,
     THRU = 341,
     GRAPH = 342,
     REST = 343,
     PRINT = 344,
     PIC = 345,
     TROFF = 346,
     UNTIL = 347,
     COLOR = 348,
     SPRINTF = 349,
     SH = 350,
     BAR = 351,
     FILL = 352,
     FILLCOLOR = 353,
     BASE = 354,
     ON = 355,
     LHS = 356,
     VFUNC1 = 357,
     CLIPPED = 358,
     UNCLIPPED = 359,
     THICKNESS = 360,
     MOD = 361,
     STRPTIME = 362,
     STRFTIME = 363
   };
#endif
/* Tokens.  */
#define NUMBER 258
#define START 259
#define END 260
#define IDENT 261
#define COPY 262
#define SEP 263
#define STRING 264
#define COORD_NAME 265
#define UNDEFINE 266
#define SOLID 267
#define INVIS 268
#define DOTTED 269
#define DASHED 270
#define DRAW 271
#define LPAREN 272
#define RPAREN 273
#define FUNC0 274
#define FUNC1 275
#define FUNC2 276
#define COMMA 277
#define LINE 278
#define PLOT 279
#define FROM 280
#define TO 281
#define AT 282
#define NEXT 283
#define FRAME 284
#define LEFT 285
#define RIGHT 286
#define TOP 287
#define BOTTOM 288
#define UP 289
#define DOWN 290
#define HT 291
#define WID 292
#define IN 293
#define OUT 294
#define NONE 295
#define TICKS 296
#define OFF 297
#define BY 298
#define GRID 299
#define LJUST 300
#define RJUST 301
#define ABOVE 302
#define BELOW 303
#define ALIGNED 304
#define PLUS 305
#define MINUS 306
#define TIMES 307
#define DIV 308
#define CARAT 309
#define EQUALS 310
#define SIZE 311
#define UNALIGNED 312
#define LABEL 313
#define RADIUS 314
#define CIRCLE 315
#define ARROW 316
#define XDIM 317
#define YDIM 318
#define LOG_X 319
#define LOG_Y 320
#define LOG_LOG 321
#define COORD 322
#define TEXT 323
#define DEFINE 324
#define IF 325
#define THEN 326
#define ELSE 327
#define EQ 328
#define NEQ 329
#define LT 330
#define GT 331
#define LTE 332
#define GTE 333
#define NOT 334
#define OR 335
#define AND 336
#define FOR 337
#define DO 338
#define MACRO 339
#define COPYTEXT 340
#define THRU 341
#define GRAPH 342
#define REST 343
#define PRINT 344
#define PIC 345
#define TROFF 346
#define UNTIL 347
#define COLOR 348
#define SPRINTF 349
#define SH 350
#define BAR 351
#define FILL 352
#define FILLCOLOR 353
#define BASE 354
#define ON 355
#define LHS 356
#define VFUNC1 357
#define CLIPPED 358
#define UNCLIPPED 359
#define THICKNESS 360
#define MOD 361
#define STRPTIME 362
#define STRFTIME 363




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 135 "grap.yy"

    int val;
    double num;
    string *String;
    DisplayString *ds;
    frame *frameptr;
    shiftdesc *shift;
    shiftlist *shift_list;
    point *pt;
    linedesc *lined;
    stringlist *string_list;
    linelist *line_list;
    ticklist *tick_list;
    doublelist *double_list;
    doublevec *double_vec;
    macro *macro_val;
    coord *coordptr;
    line *lineptr;
    sides side;
    bydesc by;
    axisdesc axistype;
    axis axisname;
    strmod stringmod;
    copydesc *copyd;
    bar_param *bar_p;



/* Line 214 of yacc.c  */
#line 477 "grap.cc"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 489 "grap.cc"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   780

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  109
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  93
/* YYNRULES -- Number of rules.  */
#define YYNRULES  231
/* YYNRULES -- Number of states.  */
#define YYNSTATES  446

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   363

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     4,     7,     8,    13,    14,    17,    19,
      21,    23,    25,    27,    29,    31,    33,    35,    37,    39,
      41,    43,    45,    47,    49,    51,    53,    55,    57,    59,
      61,    63,    65,    67,    69,    71,    72,    74,    75,    77,
      78,    81,    83,    90,    97,    99,   103,   104,   106,   107,
     109,   110,   113,   115,   117,   120,   123,   126,   129,   132,
     135,   137,   140,   141,   148,   151,   153,   156,   158,   161,
     165,   169,   173,   177,   181,   185,   189,   192,   196,   201,
     208,   212,   214,   216,   218,   220,   224,   226,   230,   234,
     238,   242,   246,   250,   254,   258,   261,   265,   269,   272,
     274,   277,   281,   287,   290,   297,   298,   302,   307,   310,
     313,   316,   319,   322,   325,   328,   331,   335,   338,   342,
     347,   354,   361,   364,   367,   369,   372,   374,   376,   378,
     380,   382,   385,   389,   392,   396,   400,   404,   409,   414,
     419,   424,   430,   436,   439,   442,   445,   448,   450,   452,
     453,   456,   459,   464,   465,   468,   472,   476,   480,   484,
     488,   496,   498,   500,   503,   504,   511,   515,   520,   526,
     527,   530,   538,   546,   552,   553,   556,   563,   565,   567,
     576,   577,   582,   583,   588,   591,   592,   594,   596,   598,
     605,   606,   609,   611,   615,   616,   623,   624,   625,   635,
     636,   637,   644,   645,   650,   651,   656,   657,   658,   662,
     663,   671,   672,   684,   685,   686,   693,   697,   699,   701,
     702,   707,   710,   712,   714,   717,   720,   723,   725,   728,
     735,   743
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     110,     0,    -1,    -1,   110,   111,    -1,    -1,     4,   112,
     113,     5,    -1,    -1,   113,   114,    -1,   135,    -1,   128,
      -1,   148,    -1,   126,    -1,   142,    -1,   141,    -1,   158,
      -1,   160,    -1,   161,    -1,   163,    -1,   200,    -1,   165,
      -1,   170,    -1,   172,    -1,   176,    -1,   179,    -1,   185,
      -1,   187,    -1,   189,    -1,   192,    -1,   181,    -1,   194,
      -1,   196,    -1,   201,    -1,     8,    -1,    25,    -1,    55,
      -1,    -1,    10,    -1,    -1,     6,    -1,    -1,   119,   139,
      -1,     9,    -1,    94,    17,     9,    22,   120,    18,    -1,
     108,    17,   119,    22,   131,    18,    -1,   131,    -1,   120,
      22,   131,    -1,    -1,   131,    -1,    -1,   125,    -1,    -1,
     149,   123,    -1,    13,    -1,    12,    -1,    14,   121,    -1,
      15,   121,    -1,    93,   119,    -1,    97,   121,    -1,    98,
     119,    -1,   105,   121,    -1,   124,    -1,   125,   124,    -1,
      -1,    16,   127,   117,   122,   118,     8,    -1,   130,     8,
      -1,     3,    -1,    51,     3,    -1,   129,    -1,   130,   129,
      -1,   130,    22,   129,    -1,   131,    50,   131,    -1,   131,
      51,   131,    -1,   131,    52,   131,    -1,   131,    53,   131,
      -1,   131,   106,   131,    -1,   131,    54,   131,    -1,    51,
     131,    -1,    19,    17,    18,    -1,    20,    17,   131,    18,
      -1,    21,    17,   131,    22,   131,    18,    -1,    17,   131,
      18,    -1,   138,    -1,     6,    -1,     3,    -1,   131,    -1,
      17,   133,    18,    -1,   133,    -1,   132,    73,   132,    -1,
     132,    74,   132,    -1,   132,    75,   132,    -1,   132,    76,
     132,    -1,   132,    77,   132,    -1,   132,    78,   132,    -1,
     132,    81,   132,    -1,   132,    80,   132,    -1,    79,   132,
      -1,   119,    73,   119,    -1,   119,    74,   119,    -1,   131,
       8,    -1,   135,    -1,   101,   134,    -1,   131,    22,   131,
      -1,    17,   131,    22,   131,    18,    -1,   116,   136,    -1,
     107,    17,   119,    22,   119,    18,    -1,    -1,   139,    56,
     131,    -1,   139,    56,    50,   131,    -1,   139,    45,    -1,
     139,    46,    -1,   139,    47,    -1,   139,    48,    -1,   139,
      49,    -1,   139,    57,    -1,   139,   103,    -1,   139,   104,
      -1,   139,    93,     9,    -1,   119,   139,    -1,   140,   119,
     139,    -1,   140,    27,   137,     8,    -1,    24,   121,   118,
      27,   137,     8,    -1,    28,   117,    27,   137,   122,     8,
      -1,    36,   131,    -1,    37,   131,    -1,   143,    -1,   144,
     143,    -1,    32,    -1,    33,    -1,    30,    -1,    31,    -1,
     144,    -1,   145,   125,    -1,   147,   145,   125,    -1,    29,
       8,    -1,    29,   125,     8,    -1,    29,   146,     8,    -1,
      29,   147,     8,    -1,    29,   146,   147,     8,    -1,    29,
     125,   147,     8,    -1,    29,   125,   146,     8,    -1,    29,
     146,   125,     8,    -1,    29,   125,   146,   147,     8,    -1,
      29,   146,   125,   147,     8,    -1,    34,   131,    -1,    35,
     131,    -1,    30,   131,    -1,    31,   131,    -1,    38,    -1,
      39,    -1,    -1,   150,   121,    -1,   131,   118,    -1,   152,
      22,   131,   118,    -1,    -1,    43,   131,    -1,    43,    50,
     131,    -1,    43,    52,   131,    -1,    43,    53,   131,    -1,
      43,   106,   131,    -1,    27,   116,   152,    -1,   115,   116,
     131,    26,   131,   153,   118,    -1,   154,    -1,   155,    -1,
     100,   117,    -1,    -1,    41,   145,   151,   123,   156,     8,
      -1,    41,    42,     8,    -1,    41,   145,    42,     8,    -1,
      41,   145,   151,   157,     8,    -1,    -1,    41,    42,    -1,
      44,   145,   159,   122,   123,   156,     8,    -1,    44,   145,
     159,   122,   123,   157,     8,    -1,    58,   145,   140,   123,
       8,    -1,    -1,    59,   131,    -1,    60,    27,   137,   162,
     122,     8,    -1,    23,    -1,    61,    -1,   164,   122,    25,
     137,    26,   137,   122,     8,    -1,    -1,    62,   131,    22,
     131,    -1,    -1,    63,   131,    22,   131,    -1,   168,   169,
      -1,    -1,    64,    -1,    65,    -1,    66,    -1,    67,   117,
     166,   167,   168,     8,    -1,    -1,    92,   119,    -1,   119,
      -1,     7,   119,     8,    -1,    -1,     7,    92,   119,     8,
     173,    85,    -1,    -1,    -1,     7,   171,    86,   174,    84,
     171,     8,   175,    85,    -1,    -1,    -1,    69,   177,     6,
     178,    68,     8,    -1,    -1,    11,   180,     6,     8,    -1,
      -1,    95,   182,    68,     8,    -1,    -1,    -1,    72,   184,
      68,    -1,    -1,    70,   132,    71,   186,    68,   183,     8,
      -1,    -1,    82,     6,   115,   131,    26,   131,   153,    83,
     188,    68,     8,    -1,    -1,    -1,    87,   190,     6,   191,
      88,     8,    -1,    89,   193,     8,    -1,   119,    -1,   131,
      -1,    -1,    90,   195,    88,     8,    -1,    91,     8,    -1,
      31,    -1,    34,    -1,    36,   131,    -1,    37,   131,    -1,
      99,   131,    -1,   198,    -1,   199,   198,    -1,    96,   137,
      22,   137,   122,     8,    -1,    96,   197,   116,   131,   199,
     122,     8,    -1,   102,    17,   131,    18,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   194,   194,   195,   199,   199,   213,   214,   218,   220,
     222,   228,   230,   232,   234,   236,   238,   240,   242,   244,
     246,   248,   250,   252,   254,   256,   258,   260,   262,   264,
     266,   268,   270,   274,   275,   278,   279,   284,   285,   290,
     291,   299,   301,   366,   391,   396,   404,   405,   410,   411,
     416,   417,   426,   428,   430,   432,   434,   436,   438,   440,
     445,   447,   452,   452,   457,   462,   465,   470,   475,   480,
     488,   490,   492,   494,   496,   498,   500,   502,   504,   506,
     508,   510,   512,   525,   530,   532,   534,   539,   541,   543,
     545,   547,   549,   551,   553,   555,   557,   559,   564,   565,
     569,   574,   576,   580,   585,   602,   609,   611,   613,   615,
     617,   619,   621,   623,   625,   627,   629,   634,   644,   649,
     653,   658,   663,   669,   678,   680,   691,   693,   695,   697,
     702,   720,   725,   751,   753,   755,   757,   759,   761,   763,
     765,   767,   769,   774,   776,   778,   780,   785,   787,   792,
     793,   801,   803,   808,   809,   815,   817,   819,   821,   826,
     835,   839,   841,   846,   862,   868,   870,   875,   877,   885,
     886,   891,   895,   906,   925,   926,   931,   939,   941,   946,
     951,   952,   956,   957,   962,   965,   969,   971,   973,   979,
     987,   988,   995,  1010,  1016,  1015,  1037,  1038,  1037,  1120,
    1121,  1120,  1126,  1126,  1134,  1134,  1154,  1155,  1155,  1164,
    1164,  1178,  1177,  1186,  1186,  1186,  1213,  1217,  1222,  1229,
    1229,  1233,  1238,  1240,  1247,  1248,  1249,  1253,  1254,  1269,
    1276,  1290
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER", "START", "END", "IDENT",
  "COPY", "SEP", "STRING", "COORD_NAME", "UNDEFINE", "SOLID", "INVIS",
  "DOTTED", "DASHED", "DRAW", "LPAREN", "RPAREN", "FUNC0", "FUNC1",
  "FUNC2", "COMMA", "LINE", "PLOT", "FROM", "TO", "AT", "NEXT", "FRAME",
  "LEFT", "RIGHT", "TOP", "BOTTOM", "UP", "DOWN", "HT", "WID", "IN", "OUT",
  "NONE", "TICKS", "OFF", "BY", "GRID", "LJUST", "RJUST", "ABOVE", "BELOW",
  "ALIGNED", "PLUS", "MINUS", "TIMES", "DIV", "CARAT", "EQUALS", "SIZE",
  "UNALIGNED", "LABEL", "RADIUS", "CIRCLE", "ARROW", "XDIM", "YDIM",
  "LOG_X", "LOG_Y", "LOG_LOG", "COORD", "TEXT", "DEFINE", "IF", "THEN",
  "ELSE", "EQ", "NEQ", "LT", "GT", "LTE", "GTE", "NOT", "OR", "AND", "FOR",
  "DO", "MACRO", "COPYTEXT", "THRU", "GRAPH", "REST", "PRINT", "PIC",
  "TROFF", "UNTIL", "COLOR", "SPRINTF", "SH", "BAR", "FILL", "FILLCOLOR",
  "BASE", "ON", "LHS", "VFUNC1", "CLIPPED", "UNCLIPPED", "THICKNESS",
  "MOD", "STRPTIME", "STRFTIME", "$accept", "graphs", "graph", "$@1",
  "prog", "statement", "from", "opt_coordname", "opt_ident",
  "opt_display_string", "string", "expr_list", "opt_expr", "opt_linedesc",
  "opt_shift", "linedesc_elem", "linedesc", "draw_statement", "$@2",
  "num_list", "num_line_elem", "num_line", "expr", "lexpr", "pure_lexpr",
  "right_hand_side", "assignment_statement", "coord_pair", "point",
  "time_expr", "strmod", "strlist", "plot_statement", "next_statement",
  "size_elem", "size", "side", "final_size", "sides", "frame_statement",
  "shift", "tickdir", "direction", "ticklist", "by_clause", "tickat",
  "tickfor", "tickdesc", "autotick", "ticks_statement", "opt_tick_off",
  "grid_statement", "label_statement", "radius_spec", "circle_statement",
  "line_token", "line_statement", "x_axis_desc", "y_axis_desc", "log_list",
  "log_desc", "coord_statement", "until_clause", "copy_statement", "$@3",
  "$@4", "$@5", "define_statement", "$@6", "$@7", "undefine_statement",
  "$@8", "sh_statement", "$@9", "else_clause", "$@10", "if_statement",
  "$@11", "for_statement", "$@12", "graph_statement", "$@13", "$@14",
  "print_statement", "print_param", "pic_statement", "$@15", "troff_line",
  "bar_dir", "bar_param", "bar_params", "bar_statement", "void_function", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,   360,   361,   362,   363
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   109,   110,   110,   112,   111,   113,   113,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   114,
     114,   114,   114,   115,   115,   116,   116,   117,   117,   118,
     118,   119,   119,   119,   120,   120,   121,   121,   122,   122,
     123,   123,   124,   124,   124,   124,   124,   124,   124,   124,
     125,   125,   127,   126,   128,   129,   129,   130,   130,   130,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   132,   132,   132,   133,   133,   133,
     133,   133,   133,   133,   133,   133,   133,   133,   134,   134,
     135,   136,   136,   137,   138,   139,   139,   139,   139,   139,
     139,   139,   139,   139,   139,   139,   139,   140,   140,   141,
     141,   142,   143,   143,   144,   144,   145,   145,   145,   145,
     146,   147,   147,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   149,   149,   149,   149,   150,   150,   151,
     151,   152,   152,   153,   153,   153,   153,   153,   153,   154,
     155,   156,   156,   157,   157,   158,   158,   158,   158,   159,
     159,   160,   160,   161,   162,   162,   163,   164,   164,   165,
     166,   166,   167,   167,   168,   168,   169,   169,   169,   170,
     171,   171,   171,   172,   173,   172,   174,   175,   172,   177,
     178,   176,   180,   179,   182,   181,   183,   184,   183,   186,
     185,   188,   187,   190,   191,   189,   192,   193,   193,   195,
     194,   196,   197,   197,   198,   198,   198,   199,   199,   200,
     200,   201
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     0,     4,     0,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     0,     1,     0,
       2,     1,     6,     6,     1,     3,     0,     1,     0,     1,
       0,     2,     1,     1,     2,     2,     2,     2,     2,     2,
       1,     2,     0,     6,     2,     1,     2,     1,     2,     3,
       3,     3,     3,     3,     3,     3,     2,     3,     4,     6,
       3,     1,     1,     1,     1,     3,     1,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     3,     3,     2,     1,
       2,     3,     5,     2,     6,     0,     3,     4,     2,     2,
       2,     2,     2,     2,     2,     2,     3,     2,     3,     4,
       6,     6,     2,     2,     1,     2,     1,     1,     1,     1,
       1,     2,     3,     2,     3,     3,     3,     4,     4,     4,
       4,     5,     5,     2,     2,     2,     2,     1,     1,     0,
       2,     2,     4,     0,     2,     3,     3,     3,     3,     3,
       7,     1,     1,     2,     0,     6,     3,     4,     5,     0,
       2,     7,     7,     5,     0,     2,     6,     1,     1,     8,
       0,     4,     0,     4,     2,     0,     1,     1,     1,     6,
       0,     2,     1,     3,     0,     6,     0,     0,     9,     0,
       0,     6,     0,     4,     0,     4,     0,     0,     3,     0,
       7,     0,    11,     0,     0,     6,     3,     1,     1,     0,
       4,     2,     1,     1,     2,     2,     2,     1,     2,     6,
       7,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,     0,     1,     4,     3,     6,     0,    65,     5,   190,
      32,    41,   202,    62,   177,    46,    37,     0,     0,     0,
       0,     0,     0,   178,    37,   199,     0,     0,   213,     0,
     219,     0,     0,   204,    35,     0,     0,     0,     7,   105,
      11,     9,    67,     0,     8,     0,    13,    12,    10,    14,
      15,    16,    17,    48,    19,    20,    21,    22,    23,    28,
      24,    25,    26,    27,    29,    30,    18,    31,     0,   192,
       0,     0,    37,    83,    82,     0,     0,     0,     0,     0,
       0,    39,    47,    81,    38,     0,   133,    53,    52,    46,
      46,   128,   129,   126,   127,     0,     0,     0,    46,     0,
      46,    60,     0,   124,   130,     0,     0,     0,     0,   149,
     169,    66,     0,    35,   180,     0,     0,     0,     0,    84,
       0,    86,     0,     0,   217,   218,     0,     0,   221,     0,
       0,    36,   222,   223,     0,     0,    35,     0,   100,    99,
       0,     0,   117,    64,     0,    68,    35,   105,     0,    49,
     191,   193,   196,     0,    48,     0,     0,     0,     0,    76,
       0,     0,   105,     0,     0,     0,     0,     0,     0,    35,
      54,    55,   122,   123,    56,    57,    58,    59,   134,    61,
       0,     0,   125,   131,   135,     0,     0,   136,     0,   166,
     147,   148,     0,    46,    50,     0,    48,    50,   174,     0,
     182,   200,    84,     0,    86,    95,     0,     0,   209,     0,
       0,     0,     0,     0,     0,     0,     0,    33,    34,     0,
     214,   216,     0,     0,     0,     0,     0,   103,    35,     0,
      98,     0,     0,   108,   109,   110,   111,   112,     0,   113,
       0,   114,   115,    69,     0,   118,    35,   194,     0,   203,
      39,    80,    77,     0,     0,     0,    35,    40,    70,    71,
      72,    73,    75,    74,    48,   139,     0,   138,   140,     0,
     137,   132,   167,   150,     0,     0,     0,     0,    37,     0,
      50,     0,   170,    50,     0,     0,    48,     0,     0,   185,
       0,    85,    96,    97,     0,    87,    88,    89,    90,    91,
      92,    94,    93,     0,     0,   220,     0,   205,     0,     0,
      48,     0,   231,     0,     0,   106,   116,   119,     0,     0,
     190,     0,    78,     0,     0,     0,     0,   141,   142,   145,
     146,   143,   144,   163,    35,    35,   161,   162,     0,    51,
     168,   164,   173,   175,     0,     0,     0,     0,     0,   206,
       0,     0,     0,    44,     0,   101,     0,     0,     0,     0,
     227,    48,     0,   107,    35,   195,     0,   192,     0,    63,
       0,     0,   120,   121,     0,     0,   165,     0,     0,   176,
     181,     0,   189,   186,   187,   188,   184,   201,   207,     0,
     153,   215,    42,     0,     0,   229,   224,   225,   226,     0,
     228,    43,    48,   191,   197,    79,   104,    39,   159,     0,
     171,   172,   183,     0,   210,     0,     0,    45,   102,   230,
       0,     0,   151,     0,     0,   208,     0,     0,     0,     0,
     154,   211,   179,   198,    39,   153,   155,   156,   157,   158,
       0,   152,    39,     0,   160,   212
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,     4,     5,     6,    38,   335,   134,    85,   161,
     118,   352,    81,   148,   279,   101,   149,    40,    72,    41,
      42,    43,   119,   120,   121,   138,    44,   227,   135,    83,
     142,    45,    46,    47,   103,   104,   105,   106,   107,    48,
     280,   193,   194,   408,   416,   336,   337,   338,   281,    49,
     196,    50,    51,   286,    52,    53,    54,   200,   289,   347,
     386,    55,    70,    56,   319,   248,   421,    57,   115,   290,
      58,    71,    59,   130,   389,   413,    60,   294,    61,   440,
      62,   123,   304,    63,   126,    64,   127,    65,   136,   360,
     361,    66,    67
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -239
static const yytype_int16 yypact[] =
{
    -239,    84,  -239,  -239,  -239,  -239,   403,  -239,  -239,    13,
    -239,  -239,  -239,  -239,  -239,    52,    -4,   325,   270,   177,
      38,   177,    15,  -239,    -4,  -239,     8,    46,  -239,   120,
    -239,    69,    27,  -239,   192,    44,    43,    72,  -239,  -239,
    -239,  -239,  -239,    32,  -239,    58,  -239,  -239,  -239,  -239,
    -239,  -239,  -239,   280,  -239,  -239,  -239,  -239,  -239,  -239,
    -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,    39,    78,
      12,   118,    -4,  -239,  -239,    52,   125,   133,   138,    52,
     150,    39,   674,  -239,  -239,   143,  -239,  -239,  -239,    52,
      52,  -239,  -239,  -239,  -239,    52,    52,    39,    52,    39,
      52,  -239,   444,  -239,   -18,   280,   488,   241,   164,   119,
     134,  -239,    39,   167,   112,   187,     8,     8,   -41,   674,
     664,  -239,    45,   188,  -239,   674,   195,   124,  -239,   204,
     152,  -239,  -239,  -239,   178,   196,   167,    28,  -239,  -239,
      52,    39,   666,  -239,    17,  -239,   167,  -239,   199,   280,
     223,  -239,  -239,   227,   280,   336,   224,    52,    52,  -239,
      39,   210,  -239,    52,    52,    52,    52,    52,    52,   167,
    -239,  -239,   674,   674,  -239,  -239,  -239,  -239,  -239,  -239,
     333,   361,  -239,   280,  -239,   501,   435,  -239,   280,  -239,
    -239,  -239,   235,    52,   316,   206,   280,   274,   191,    52,
     183,  -239,   336,   687,   239,  -239,    39,    39,  -239,     8,
       8,     8,     8,     8,     8,     8,     8,  -239,  -239,    52,
    -239,  -239,   246,   240,   250,    52,   588,  -239,   167,    52,
    -239,   517,   245,  -239,  -239,  -239,  -239,  -239,   219,  -239,
     259,  -239,  -239,  -239,   276,   666,   167,  -239,   207,  -239,
      39,  -239,  -239,   522,   599,   284,   167,   666,   111,   111,
     257,   257,  -239,   257,   280,  -239,   520,  -239,  -239,   614,
    -239,   280,  -239,  -239,    52,    52,    52,    52,    -4,   121,
     318,   305,  -239,   318,   313,    52,   280,   604,    52,  -239,
     254,  -239,  -239,  -239,   255,  -239,  -239,  -239,  -239,  -239,
    -239,   698,   698,   645,   237,  -239,    52,  -239,   508,    52,
     280,   637,  -239,    52,    52,   674,  -239,  -239,   301,   244,
      36,   324,  -239,    52,    39,   326,   335,  -239,  -239,   674,
     674,   674,   674,  -239,   167,   167,  -239,  -239,   351,  -239,
    -239,    49,  -239,   674,   362,    52,   612,   251,   363,   302,
      52,   367,   109,   674,    52,   674,   375,    52,    52,    52,
    -239,   510,   537,   674,   167,  -239,    39,  -239,   376,  -239,
     566,   377,  -239,  -239,    52,    52,  -239,   390,   391,  -239,
     674,    52,  -239,  -239,  -239,  -239,  -239,  -239,  -239,   392,
     627,  -239,  -239,    52,   579,  -239,   674,   674,   674,   394,
    -239,  -239,   280,  -239,  -239,  -239,  -239,   236,   382,   650,
    -239,  -239,   674,   337,  -239,   213,   330,   674,  -239,  -239,
     399,   332,  -239,    52,    52,  -239,    52,    52,    52,    52,
     674,  -239,  -239,  -239,   236,   627,   674,   674,   674,   674,
     341,  -239,    39,   412,  -239,  -239
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -239,  -239,  -239,  -239,  -239,  -239,   299,  -129,   -23,  -238,
      -6,  -239,   -74,  -150,  -184,   -93,     4,  -239,  -239,  -239,
     -12,  -239,    22,    66,   308,  -239,   398,  -239,  -103,  -239,
    -109,   317,  -239,  -239,   321,  -239,   -13,   338,   -72,  -239,
    -239,  -239,  -239,  -239,    -1,  -239,  -239,    94,    97,  -239,
    -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,
    -239,  -239,   135,  -239,  -239,  -239,  -239,  -239,  -239,  -239,
    -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,
    -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,  -239,    80,
    -239,  -239,  -239
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -165
static const yytype_int16 yytable[] =
{
      39,   114,    84,    69,   250,   109,   110,   229,   112,   179,
     198,    73,   321,   284,    74,   170,   171,    11,    95,    96,
       7,   102,    11,   124,   175,   116,   177,    76,    77,    78,
     181,   145,   206,   207,   186,     7,   230,    82,   245,   147,
     143,   111,   113,   244,   129,    11,   283,    73,    11,   154,
      74,   125,   122,   257,   144,    73,   179,   137,    74,    79,
     140,    75,   150,    76,    77,    78,   264,    11,    20,    75,
     217,    76,    77,    78,   217,   162,   334,   128,   163,   164,
     165,   166,   167,    20,     2,   146,   151,   117,     3,   141,
     179,   174,   179,   176,   188,    79,   339,   155,   152,   341,
     218,   159,    32,    79,   218,    68,    39,    32,   266,   183,
     185,    82,    82,   269,   326,    80,    37,   172,   173,   273,
      82,    37,    82,    73,   153,   310,    74,   392,   366,    11,
      32,   393,   243,    32,   168,   232,   344,    75,   202,    76,
      77,    78,   156,   318,    37,    35,   217,    37,   334,   278,
     157,    80,    32,   325,   255,   158,   226,   190,   191,    80,
     356,   192,   231,   165,   166,   167,    37,   160,   188,   422,
     169,    79,   189,   188,   199,   195,   218,   131,   179,   253,
     254,    73,   203,   205,    74,   258,   259,   260,   261,   262,
     263,   147,   271,   201,   220,   225,   441,    76,    77,    78,
     292,   293,   131,   221,   444,   374,   375,    91,    92,    93,
      94,   399,   222,   223,    32,    82,    73,   168,   228,    74,
     224,   287,    73,   132,   246,    74,   133,    80,    37,    79,
      75,   247,    76,    77,    78,   249,    75,   256,    76,    77,
      78,   303,   252,   272,   162,    11,   288,   308,   282,   187,
     285,   311,   420,   188,   305,   333,   188,   291,   307,   382,
     315,   402,   306,   426,    79,   427,   428,   313,   316,   314,
      79,    91,    92,    93,    94,   295,   296,   297,   298,   299,
     300,   301,   302,    11,   317,    80,   163,   164,   165,   166,
     167,   320,    87,    88,    89,    90,   329,   330,   331,   332,
      91,    92,    93,    94,   274,   275,   324,   343,   276,   277,
     346,   167,   108,   340,   367,   383,   384,   385,   371,   429,
      80,   342,   348,   349,  -164,   351,    80,   364,   353,   365,
      32,   355,   369,    86,   372,   362,   363,    87,    88,    89,
      90,   265,   168,   373,    37,   370,   274,   275,   274,   275,
     276,   277,   276,   277,   251,    91,    92,    93,    94,   376,
     403,    95,    96,    91,    92,    93,    94,   380,    32,   267,
     379,   387,   390,    97,   388,   391,   394,    98,    99,   396,
     397,   398,    37,   395,   404,   100,   163,   164,   165,   166,
     167,    91,    92,    93,    94,   406,   407,   409,   410,   411,
     414,   162,   419,   412,   423,   425,     7,   432,     8,   443,
       9,    10,    11,   431,    12,   417,   278,   433,    97,    13,
     445,   219,    98,    99,   204,   182,    14,    15,   162,   197,
     100,    16,    17,   139,   442,   377,   162,   430,   378,     0,
     180,   400,   168,   270,    18,   434,   435,    19,   436,   437,
     438,   439,   178,     0,    20,   368,    87,    88,    89,    90,
       0,    21,     0,    22,    23,    91,    92,    93,    94,     0,
      24,     0,    25,    26,    91,    92,    93,    94,     0,     0,
      95,    96,     0,     0,     0,    27,     0,     0,     0,     0,
      28,     0,    29,    30,    31,     0,   184,    32,    33,    34,
      87,    88,    89,    90,    35,    36,     0,     0,     0,   268,
       0,    37,     0,    87,    88,    89,    90,     0,    91,    92,
      93,    94,    87,    88,    89,    90,   251,     0,   327,     0,
     354,    91,    92,    93,    94,   312,     0,    97,     0,     0,
     322,    98,    99,     0,     0,     0,   357,   358,     0,   100,
      91,    92,    93,    94,     0,   401,     0,     0,   163,   164,
     165,   166,   167,     0,     0,     0,     0,   163,   164,   165,
     166,   167,   163,   164,   165,   166,   167,     0,     0,     0,
       0,    97,     0,     0,   405,    98,    99,   163,   164,   165,
     166,   167,     0,   100,    97,     0,     0,   418,    98,    99,
       0,     0,     0,    97,     0,     0,   100,    98,    99,   359,
     309,     0,     0,     0,   168,   100,   163,   164,   165,   166,
     167,   323,   328,   168,     0,     0,   345,     0,   168,   163,
     164,   165,   166,   167,   381,     0,     0,     0,   163,   164,
     165,   166,   167,   168,    91,    92,    93,    94,     0,   163,
     164,   165,   166,   167,   163,   164,   165,   166,   167,     0,
       0,     0,   163,   164,   165,   166,   167,     0,     0,     0,
     415,   350,   168,   357,   358,     0,   424,   163,   164,   165,
     166,   167,     0,     0,     0,   168,     0,   163,   164,   165,
     166,   167,     0,     0,   168,   163,   164,   165,   166,   167,
     163,   164,   165,   166,   167,   168,     0,     0,     0,     0,
     168,   233,   234,   235,   236,   237,     0,     0,   168,     0,
       0,     0,   238,   239,   163,   164,   165,   166,   167,     0,
       0,     0,     0,   168,     0,   208,   359,   209,   210,   211,
     212,   213,   214,   168,   215,   216,     0,     0,     0,     0,
       0,   168,     0,     0,     0,     0,   168,     0,     0,   240,
     209,   210,   211,   212,   213,   214,     0,   215,   216,   241,
     242,   209,   210,   211,   212,   213,   214,     0,     0,     0,
     168
};

static const yytype_int16 yycheck[] =
{
       6,    24,     6,     9,   154,    18,    19,   136,    21,   102,
     113,     3,   250,   197,     6,    89,    90,     9,    36,    37,
       3,    17,     9,    29,    98,    17,   100,    19,    20,    21,
     102,    43,    73,    74,   106,     3,     8,    15,   147,    45,
       8,     3,    27,   146,    17,     9,   196,     3,     9,    72,
       6,    29,     6,   162,    22,     3,   149,    35,     6,    51,
      17,    17,    68,    19,    20,    21,   169,     9,    51,    17,
      25,    19,    20,    21,    25,    81,    27,     8,    50,    51,
      52,    53,    54,    51,     0,    27,     8,    79,     4,    17,
     183,    97,   185,    99,   107,    51,   280,    75,    86,   283,
      55,    79,    94,    51,    55,    92,   112,    94,   180,   105,
     106,    89,    90,   185,   264,   107,   108,    95,    96,   193,
      98,   108,   100,     3,     6,   228,     6,    18,    92,     9,
      94,    22,   144,    94,   106,   141,   286,    17,   116,    19,
      20,    21,    17,   246,   108,   101,    25,   108,    27,   100,
      17,   107,    94,   256,   160,    17,   134,    38,    39,   107,
     310,    42,   140,    52,    53,    54,   108,    17,   181,   407,
      27,    51,     8,   186,    62,    41,    55,    10,   271,   157,
     158,     3,   116,   117,     6,   163,   164,   165,   166,   167,
     168,   197,   188,     6,     6,    17,   434,    19,    20,    21,
     206,   207,    10,     8,   442,   334,   335,    30,    31,    32,
      33,   361,    88,     9,    94,   193,     3,   106,    22,     6,
      68,   199,     3,    31,    25,     6,    34,   107,   108,    51,
      17,     8,    19,    20,    21,     8,    17,    27,    19,    20,
      21,   219,    18,     8,   250,     9,    63,   225,    42,     8,
      59,   229,   402,   266,     8,   278,   269,    18,     8,     8,
     238,   364,    22,    50,    51,    52,    53,    22,     9,    50,
      51,    30,    31,    32,    33,   209,   210,   211,   212,   213,
     214,   215,   216,     9,     8,   107,    50,    51,    52,    53,
      54,    84,    12,    13,    14,    15,   274,   275,   276,   277,
      30,    31,    32,    33,    30,    31,    22,   285,    34,    35,
     288,    54,    42,     8,   320,    64,    65,    66,   324,   106,
     107,     8,    68,    68,     8,    88,   107,    26,   306,    85,
      94,   309,     8,     8,     8,   313,   314,    12,    13,    14,
      15,     8,   106,     8,   108,   323,    30,    31,    30,    31,
      34,    35,    34,    35,    18,    30,    31,    32,    33,     8,
     366,    36,    37,    30,    31,    32,    33,   345,    94,     8,
       8,     8,   350,    93,    72,     8,   354,    97,    98,   357,
     358,   359,   108,     8,     8,   105,    50,    51,    52,    53,
      54,    30,    31,    32,    33,    18,   374,   375,     8,     8,
       8,   407,     8,   381,    22,    68,     3,     8,     5,    68,
       7,     8,     9,    83,    11,   393,   100,    85,    93,    16,
       8,   122,    97,    98,   116,   104,    23,    24,   434,   112,
     105,    28,    29,    35,   435,   341,   442,   415,   341,    -1,
     102,   361,   106,     8,    41,   423,   424,    44,   426,   427,
     428,   429,     8,    -1,    51,   320,    12,    13,    14,    15,
      -1,    58,    -1,    60,    61,    30,    31,    32,    33,    -1,
      67,    -1,    69,    70,    30,    31,    32,    33,    -1,    -1,
      36,    37,    -1,    -1,    -1,    82,    -1,    -1,    -1,    -1,
      87,    -1,    89,    90,    91,    -1,     8,    94,    95,    96,
      12,    13,    14,    15,   101,   102,    -1,    -1,    -1,     8,
      -1,   108,    -1,    12,    13,    14,    15,    -1,    30,    31,
      32,    33,    12,    13,    14,    15,    18,    -1,     8,    -1,
      22,    30,    31,    32,    33,    18,    -1,    93,    -1,    -1,
      18,    97,    98,    -1,    -1,    -1,    36,    37,    -1,   105,
      30,    31,    32,    33,    -1,    18,    -1,    -1,    50,    51,
      52,    53,    54,    -1,    -1,    -1,    -1,    50,    51,    52,
      53,    54,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      -1,    93,    -1,    -1,    18,    97,    98,    50,    51,    52,
      53,    54,    -1,   105,    93,    -1,    -1,    18,    97,    98,
      -1,    -1,    -1,    93,    -1,    -1,   105,    97,    98,    99,
      22,    -1,    -1,    -1,   106,   105,    50,    51,    52,    53,
      54,    22,     8,   106,    -1,    -1,    22,    -1,   106,    50,
      51,    52,    53,    54,    22,    -1,    -1,    -1,    50,    51,
      52,    53,    54,   106,    30,    31,    32,    33,    -1,    50,
      51,    52,    53,    54,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    50,    51,    52,    53,    54,    -1,    -1,    -1,
      43,    26,   106,    36,    37,    -1,    26,    50,    51,    52,
      53,    54,    -1,    -1,    -1,   106,    -1,    50,    51,    52,
      53,    54,    -1,    -1,   106,    50,    51,    52,    53,    54,
      50,    51,    52,    53,    54,   106,    -1,    -1,    -1,    -1,
     106,    45,    46,    47,    48,    49,    -1,    -1,   106,    -1,
      -1,    -1,    56,    57,    50,    51,    52,    53,    54,    -1,
      -1,    -1,    -1,   106,    -1,    71,    99,    73,    74,    75,
      76,    77,    78,   106,    80,    81,    -1,    -1,    -1,    -1,
      -1,   106,    -1,    -1,    -1,    -1,   106,    -1,    -1,    93,
      73,    74,    75,    76,    77,    78,    -1,    80,    81,   103,
     104,    73,    74,    75,    76,    77,    78,    -1,    -1,    -1,
     106
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   110,     0,     4,   111,   112,   113,     3,     5,     7,
       8,     9,    11,    16,    23,    24,    28,    29,    41,    44,
      51,    58,    60,    61,    67,    69,    70,    82,    87,    89,
      90,    91,    94,    95,    96,   101,   102,   108,   114,   119,
     126,   128,   129,   130,   135,   140,   141,   142,   148,   158,
     160,   161,   163,   164,   165,   170,   172,   176,   179,   181,
     185,   187,   189,   192,   194,   196,   200,   201,    92,   119,
     171,   180,   127,     3,     6,    17,    19,    20,    21,    51,
     107,   121,   131,   138,     6,   117,     8,    12,    13,    14,
      15,    30,    31,    32,    33,    36,    37,    93,    97,    98,
     105,   124,   125,   143,   144,   145,   146,   147,    42,   145,
     145,     3,   145,    27,   117,   177,    17,    79,   119,   131,
     132,   133,     6,   190,   119,   131,   193,   195,     8,    17,
     182,    10,    31,    34,   116,   137,   197,   131,   134,   135,
      17,    17,   139,     8,    22,   129,    27,   119,   122,   125,
     119,     8,    86,     6,   117,   131,    17,    17,    17,   131,
      17,   118,   119,    50,    51,    52,    53,    54,   106,    27,
     121,   121,   131,   131,   119,   121,   119,   121,     8,   124,
     146,   147,   143,   125,     8,   125,   147,     8,   145,     8,
      38,    39,    42,   150,   151,    41,   159,   140,   137,    62,
     166,     6,   131,   132,   133,   132,    73,    74,    71,    73,
      74,    75,    76,    77,    78,    80,    81,    25,    55,   115,
       6,     8,    88,     9,    68,    17,   131,   136,    22,   116,
       8,   131,   119,    45,    46,    47,    48,    49,    56,    57,
      93,   103,   104,   129,   137,   139,    25,     8,   174,     8,
     122,    18,    18,   131,   131,   119,    27,   139,   131,   131,
     131,   131,   131,   131,   137,     8,   147,     8,     8,   147,
       8,   125,     8,   121,    30,    31,    34,    35,   100,   123,
     149,   157,    42,   122,   123,    59,   162,   131,    63,   167,
     178,    18,   119,   119,   186,   132,   132,   132,   132,   132,
     132,   132,   132,   131,   191,     8,    22,     8,   131,    22,
     137,   131,    18,    22,    50,   131,     9,     8,   137,   173,
      84,   118,    18,    22,    22,   137,   122,     8,     8,   131,
     131,   131,   131,   117,    27,   115,   154,   155,   156,   123,
       8,   123,     8,   131,   122,    22,   131,   168,    68,    68,
      26,    88,   120,   131,    22,   131,   122,    36,    37,    99,
     198,   199,   131,   131,    26,    85,    92,   119,   171,     8,
     131,   119,     8,     8,   116,   116,     8,   156,   157,     8,
     131,    22,     8,    64,    65,    66,   169,     8,    72,   183,
     131,     8,    18,    22,   131,     8,   131,   131,   131,   122,
     198,    18,   137,   119,     8,    18,    18,   131,   152,   131,
       8,     8,   131,   184,     8,    43,   153,   131,    18,     8,
     122,   175,   118,    22,    26,    68,    50,    52,    53,   106,
     131,    83,     8,    85,   131,   131,   131,   131,   131,   131,
     188,   118,   153,    68,   118,     8
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1464 of yacc.c  */
#line 199 "grap.yy"
    {
                if ( !the_graph)
		    the_graph = initial_graph();
		the_graph->init();
		init_dict();
		first_line = true;
		the_graph->begin_block((yyvsp[(1) - (1)].String));
	    }
    break;

  case 5:

/* Line 1464 of yacc.c  */
#line 207 "grap.yy"
    {
		the_graph->draw(0);
		the_graph->end_block();
	    }
    break;

  case 6:

/* Line 1464 of yacc.c  */
#line 213 "grap.yy"
    { }
    break;

  case 7:

/* Line 1464 of yacc.c  */
#line 215 "grap.yy"
    { }
    break;

  case 8:

/* Line 1464 of yacc.c  */
#line 219 "grap.yy"
    { first_line = false;}
    break;

  case 9:

/* Line 1464 of yacc.c  */
#line 221 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 10:

/* Line 1464 of yacc.c  */
#line 223 "grap.yy"
    {
		first_line = false;
		the_graph->queue_frame();
		the_graph->is_visible(true);
	    }
    break;

  case 11:

/* Line 1464 of yacc.c  */
#line 229 "grap.yy"
    { first_line = false; }
    break;

  case 12:

/* Line 1464 of yacc.c  */
#line 231 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 13:

/* Line 1464 of yacc.c  */
#line 233 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 14:

/* Line 1464 of yacc.c  */
#line 235 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 15:

/* Line 1464 of yacc.c  */
#line 237 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 16:

/* Line 1464 of yacc.c  */
#line 239 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 17:

/* Line 1464 of yacc.c  */
#line 241 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 18:

/* Line 1464 of yacc.c  */
#line 243 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 19:

/* Line 1464 of yacc.c  */
#line 245 "grap.yy"
    { first_line = false; the_graph->is_visible(true);}
    break;

  case 20:

/* Line 1464 of yacc.c  */
#line 247 "grap.yy"
    { first_line = false;}
    break;

  case 21:

/* Line 1464 of yacc.c  */
#line 249 "grap.yy"
    { first_line = false;}
    break;

  case 22:

/* Line 1464 of yacc.c  */
#line 251 "grap.yy"
    { first_line = false;}
    break;

  case 23:

/* Line 1464 of yacc.c  */
#line 253 "grap.yy"
    { first_line = false;}
    break;

  case 24:

/* Line 1464 of yacc.c  */
#line 255 "grap.yy"
    { first_line = false;}
    break;

  case 25:

/* Line 1464 of yacc.c  */
#line 257 "grap.yy"
    { first_line = false;}
    break;

  case 26:

/* Line 1464 of yacc.c  */
#line 259 "grap.yy"
    { first_line = false;}
    break;

  case 27:

/* Line 1464 of yacc.c  */
#line 261 "grap.yy"
    { first_line = false;}
    break;

  case 28:

/* Line 1464 of yacc.c  */
#line 263 "grap.yy"
    { first_line = false;}
    break;

  case 29:

/* Line 1464 of yacc.c  */
#line 265 "grap.yy"
    { first_line = false;}
    break;

  case 30:

/* Line 1464 of yacc.c  */
#line 267 "grap.yy"
    { first_line = false;}
    break;

  case 31:

/* Line 1464 of yacc.c  */
#line 269 "grap.yy"
    { first_line = false;}
    break;

  case 35:

/* Line 1464 of yacc.c  */
#line 278 "grap.yy"
    { (yyval.coordptr)= defcoord; }
    break;

  case 36:

/* Line 1464 of yacc.c  */
#line 280 "grap.yy"
    { (yyval.coordptr)= (yyvsp[(1) - (1)].coordptr);}
    break;

  case 37:

/* Line 1464 of yacc.c  */
#line 284 "grap.yy"
    { (yyval.String) = 0; }
    break;

  case 38:

/* Line 1464 of yacc.c  */
#line 286 "grap.yy"
    { (yyval.String) = (yyvsp[(1) - (1)].String); }
    break;

  case 39:

/* Line 1464 of yacc.c  */
#line 290 "grap.yy"
    { (yyval.ds) = 0; }
    break;

  case 40:

/* Line 1464 of yacc.c  */
#line 292 "grap.yy"
    {
		(yyval.ds) = new DisplayString(*(yyvsp[(1) - (2)].String), (yyvsp[(2) - (2)].stringmod).just, (yyvsp[(2) - (2)].stringmod).size, (yyvsp[(2) - (2)].stringmod).rel, 
		    (yyvsp[(2) - (2)].stringmod).clip, (yyvsp[(2) - (2)].stringmod).color);
	    }
    break;

  case 41:

/* Line 1464 of yacc.c  */
#line 300 "grap.yy"
    { (yyval.String) = (yyvsp[(1) - (1)].String); }
    break;

  case 42:

/* Line 1464 of yacc.c  */
#line 302 "grap.yy"
    {
		 if ( do_sprintf ) {
		     const int len = (yyvsp[(3) - (6)].String)->length() < 128 ? 256 : 2*(yyvsp[(3) - (6)].String)->length();
		     char *buf = new char[len];

		     // I really dislike this, but I dislike trying to do it
		     // incrementally more.
		     switch ((yyvsp[(5) - (6)].double_vec)->size()) {
			case 0:
			    snprintf(buf, len, "%s", (yyvsp[(3) - (6)].String)->c_str());
			    break;
			case 1:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0]);
			    break;
			case 2:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1]);
			    break;
			case 3:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2]);
			    break;
			case 4:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2], (*(yyvsp[(5) - (6)].double_vec))[3]);
			    break;
			case 5:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2], (*(yyvsp[(5) - (6)].double_vec))[3], (*(yyvsp[(5) - (6)].double_vec))[4]);
			    break;
			case 6:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2], (*(yyvsp[(5) - (6)].double_vec))[3], (*(yyvsp[(5) - (6)].double_vec))[4], (*(yyvsp[(5) - (6)].double_vec))[5]);
			    break;
			case 7:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2], (*(yyvsp[(5) - (6)].double_vec))[3], (*(yyvsp[(5) - (6)].double_vec))[4], (*(yyvsp[(5) - (6)].double_vec))[5], 
				(*(yyvsp[(5) - (6)].double_vec))[6]);
			    break;
			case 8:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2], (*(yyvsp[(5) - (6)].double_vec))[3], (*(yyvsp[(5) - (6)].double_vec))[4], (*(yyvsp[(5) - (6)].double_vec))[5], 
				(*(yyvsp[(5) - (6)].double_vec))[6], (*(yyvsp[(5) - (6)].double_vec))[7]);
			    break;
			case 9:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2], (*(yyvsp[(5) - (6)].double_vec))[3], (*(yyvsp[(5) - (6)].double_vec))[4], (*(yyvsp[(5) - (6)].double_vec))[5], 
				(*(yyvsp[(5) - (6)].double_vec))[6], (*(yyvsp[(5) - (6)].double_vec))[7], (*(yyvsp[(5) - (6)].double_vec))[8]);
			    break;
			default:
			    cerr << "more that 10 arguments to sprintf.  " << 
				"Ignoring more than 10." << endl;
			case 10:
			    snprintf(buf, len, (yyvsp[(3) - (6)].String)->c_str(), (*(yyvsp[(5) - (6)].double_vec))[0], (*(yyvsp[(5) - (6)].double_vec))[1], 
				(*(yyvsp[(5) - (6)].double_vec))[2], (*(yyvsp[(5) - (6)].double_vec))[3], (*(yyvsp[(5) - (6)].double_vec))[4], (*(yyvsp[(5) - (6)].double_vec))[5], 
				(*(yyvsp[(5) - (6)].double_vec))[6], (*(yyvsp[(5) - (6)].double_vec))[7], (*(yyvsp[(5) - (6)].double_vec))[8], (*(yyvsp[(5) - (6)].double_vec))[9]);
			    break;
		     }
		     delete (yyvsp[(5) - (6)].double_vec); delete (yyvsp[(3) - (6)].String);

		     (yyval.String) = new string(buf);
		     delete[] buf;
		 }
		 else (yyval.String) = (yyvsp[(3) - (6)].String);
	     }
    break;

  case 43:

/* Line 1464 of yacc.c  */
#line 367 "grap.yy"
    {
	         time_t t = (yyvsp[(5) - (6)].num);
	         struct tm *tm = localtime(&t);
		 const int len = 1024;
		 char *buf = new char[len];
		 bool ok = false;
		 
		 if (tm) {
		     if (strftime(buf, len, (yyvsp[(3) - (6)].String)->c_str(), tm) != 0 ) {
		     	(yyval.String) = new string(buf);
			delete buf;
			ok = true;
		     }
		}
		if ( !ok) {
		    delete buf;
		    cerr << "Cannot format " << (yyvsp[(5) - (6)].num) << " using format " 
		         << *(yyvsp[(3) - (6)].String) << endl;
		    (yyval.String) = new string("error");
	        }
	     }
    break;

  case 44:

/* Line 1464 of yacc.c  */
#line 392 "grap.yy"
    {
		(yyval.double_vec) = new doublevec;
		(yyval.double_vec)->push_back((yyvsp[(1) - (1)].num));
	    }
    break;

  case 45:

/* Line 1464 of yacc.c  */
#line 397 "grap.yy"
    {
		(yyval.double_vec) = (yyvsp[(1) - (3)].double_vec);
		(yyval.double_vec)->push_back((yyvsp[(3) - (3)].num));
	    }
    break;

  case 46:

/* Line 1464 of yacc.c  */
#line 404 "grap.yy"
    { (yyval.num) = 0; }
    break;

  case 47:

/* Line 1464 of yacc.c  */
#line 406 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 48:

/* Line 1464 of yacc.c  */
#line 410 "grap.yy"
    { (yyval.lined) = new linedesc; (yyval.lined) = 0;}
    break;

  case 49:

/* Line 1464 of yacc.c  */
#line 412 "grap.yy"
    {  (yyval.lined) = (yyvsp[(1) - (1)].lined);}
    break;

  case 50:

/* Line 1464 of yacc.c  */
#line 416 "grap.yy"
    { (yyval.shift_list) = new shiftlist;}
    break;

  case 51:

/* Line 1464 of yacc.c  */
#line 418 "grap.yy"
    {
		(yyval.shift_list) = (yyvsp[(2) - (2)].shift_list);
		(yyval.shift_list)->push_back((yyvsp[(1) - (2)].shift));
	    }
    break;

  case 52:

/* Line 1464 of yacc.c  */
#line 427 "grap.yy"
    { (yyval.lined) = new linedesc(invis); }
    break;

  case 53:

/* Line 1464 of yacc.c  */
#line 429 "grap.yy"
    { (yyval.lined) = new linedesc(solid); }
    break;

  case 54:

/* Line 1464 of yacc.c  */
#line 431 "grap.yy"
    { (yyval.lined) = new linedesc(dotted, (yyvsp[(2) - (2)].num)); }
    break;

  case 55:

/* Line 1464 of yacc.c  */
#line 433 "grap.yy"
    { (yyval.lined) = new linedesc(dashed, (yyvsp[(2) - (2)].num)); }
    break;

  case 56:

/* Line 1464 of yacc.c  */
#line 435 "grap.yy"
    { (yyval.lined) = new linedesc(def, 0, (yyvsp[(2) - (2)].String)); }
    break;

  case 57:

/* Line 1464 of yacc.c  */
#line 437 "grap.yy"
    { (yyval.lined) = new linedesc(def, 0, 0, (yyvsp[(2) - (2)].num)); }
    break;

  case 58:

/* Line 1464 of yacc.c  */
#line 439 "grap.yy"
    { (yyval.lined) = new linedesc(def, 0, 0, 0, (yyvsp[(2) - (2)].String)); }
    break;

  case 59:

/* Line 1464 of yacc.c  */
#line 441 "grap.yy"
    { (yyval.lined) = new linedesc(def, 0, 0, 0, 0, (yyvsp[(2) - (2)].num)); }
    break;

  case 60:

/* Line 1464 of yacc.c  */
#line 446 "grap.yy"
    { (yyval.lined) = (yyvsp[(1) - (1)].lined); }
    break;

  case 61:

/* Line 1464 of yacc.c  */
#line 448 "grap.yy"
    { (yyval.lined) = combine_linedesc((yyvsp[(1) - (2)].lined), (yyvsp[(2) - (2)].lined)); }
    break;

  case 62:

/* Line 1464 of yacc.c  */
#line 452 "grap.yy"
    { lex_no_coord(); }
    break;

  case 63:

/* Line 1464 of yacc.c  */
#line 453 "grap.yy"
    { draw_statement((yyvsp[(3) - (6)].String), (yyvsp[(4) - (6)].lined), (yyvsp[(5) - (6)].ds)); lex_coord_ok(); }
    break;

  case 64:

/* Line 1464 of yacc.c  */
#line 458 "grap.yy"
    { num_list((yyvsp[(1) - (2)].double_list)); }
    break;

  case 65:

/* Line 1464 of yacc.c  */
#line 463 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 66:

/* Line 1464 of yacc.c  */
#line 466 "grap.yy"
    { (yyval.num) = -(yyvsp[(2) - (2)].num); }
    break;

  case 67:

/* Line 1464 of yacc.c  */
#line 471 "grap.yy"
    {
		(yyval.double_list) = new doublelist;
		(yyval.double_list)->push_back((yyvsp[(1) - (1)].num));
	    }
    break;

  case 68:

/* Line 1464 of yacc.c  */
#line 476 "grap.yy"
    {
		(yyval.double_list) = (yyvsp[(1) - (2)].double_list);
		(yyval.double_list)->push_back((yyvsp[(2) - (2)].num));
	    }
    break;

  case 69:

/* Line 1464 of yacc.c  */
#line 481 "grap.yy"
    {
		(yyval.double_list) = (yyvsp[(1) - (3)].double_list);
		(yyval.double_list)->push_back((yyvsp[(3) - (3)].num));
	    }
    break;

  case 70:

/* Line 1464 of yacc.c  */
#line 489 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (3)].num) + (yyvsp[(3) - (3)].num); }
    break;

  case 71:

/* Line 1464 of yacc.c  */
#line 491 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (3)].num) - (yyvsp[(3) - (3)].num); }
    break;

  case 72:

/* Line 1464 of yacc.c  */
#line 493 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (3)].num) * (yyvsp[(3) - (3)].num); }
    break;

  case 73:

/* Line 1464 of yacc.c  */
#line 495 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (3)].num) / (yyvsp[(3) - (3)].num); }
    break;

  case 74:

/* Line 1464 of yacc.c  */
#line 497 "grap.yy"
    { (yyval.num) = static_cast<int>((yyvsp[(1) - (3)].num)) % static_cast<int>((yyvsp[(3) - (3)].num)); }
    break;

  case 75:

/* Line 1464 of yacc.c  */
#line 499 "grap.yy"
    { (yyval.num) = pow((yyvsp[(1) - (3)].num),(yyvsp[(3) - (3)].num));}
    break;

  case 76:

/* Line 1464 of yacc.c  */
#line 501 "grap.yy"
    { (yyval.num) = - (yyvsp[(2) - (2)].num);}
    break;

  case 77:

/* Line 1464 of yacc.c  */
#line 503 "grap.yy"
    { (yyval.num) = ( (yyvsp[(1) - (3)].val) >=0 && (yyvsp[(1) - (3)].val) < NF0 ) ? jtf0[(yyvsp[(1) - (3)].val)]() : 0; }
    break;

  case 78:

/* Line 1464 of yacc.c  */
#line 505 "grap.yy"
    { (yyval.num) = ( (yyvsp[(1) - (4)].val) >=0 && (yyvsp[(1) - (4)].val) < NF1 ) ? jtf1[(yyvsp[(1) - (4)].val)]((yyvsp[(3) - (4)].num)) : 0; }
    break;

  case 79:

/* Line 1464 of yacc.c  */
#line 507 "grap.yy"
    { (yyval.num) = ( (yyvsp[(1) - (6)].val) >=0 && (yyvsp[(1) - (6)].val) < NF2 ) ? jtf2[(yyvsp[(1) - (6)].val)]((yyvsp[(3) - (6)].num), (yyvsp[(5) - (6)].num)) : 0; }
    break;

  case 80:

/* Line 1464 of yacc.c  */
#line 509 "grap.yy"
    { (yyval.num) = (yyvsp[(2) - (3)].num); }
    break;

  case 81:

/* Line 1464 of yacc.c  */
#line 511 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 82:

/* Line 1464 of yacc.c  */
#line 513 "grap.yy"
    {
		doubleDictionary::iterator di;
		
		if ( (di = vars.find(*(yyvsp[(1) - (1)].String))) != vars.end())
		    (yyval.num) = *(*di).second;
		else {
		    cerr << *(yyvsp[(1) - (1)].String) << " is uninitialized, using 0.0" << endl;
		    (yyval.num) = 0.0;
		}

		delete (yyvsp[(1) - (1)].String);
	     }
    break;

  case 83:

/* Line 1464 of yacc.c  */
#line 526 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 84:

/* Line 1464 of yacc.c  */
#line 531 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 85:

/* Line 1464 of yacc.c  */
#line 533 "grap.yy"
    { (yyval.num) = (yyvsp[(2) - (3)].num); }
    break;

  case 86:

/* Line 1464 of yacc.c  */
#line 535 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 87:

/* Line 1464 of yacc.c  */
#line 540 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) == (yyvsp[(3) - (3)].num)); }
    break;

  case 88:

/* Line 1464 of yacc.c  */
#line 542 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) != (yyvsp[(3) - (3)].num)); }
    break;

  case 89:

/* Line 1464 of yacc.c  */
#line 544 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) < (yyvsp[(3) - (3)].num)); }
    break;

  case 90:

/* Line 1464 of yacc.c  */
#line 546 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) > (yyvsp[(3) - (3)].num)); }
    break;

  case 91:

/* Line 1464 of yacc.c  */
#line 548 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) <= (yyvsp[(3) - (3)].num)); }
    break;

  case 92:

/* Line 1464 of yacc.c  */
#line 550 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) >= (yyvsp[(3) - (3)].num)); }
    break;

  case 93:

/* Line 1464 of yacc.c  */
#line 552 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) && (yyvsp[(3) - (3)].num)); }
    break;

  case 94:

/* Line 1464 of yacc.c  */
#line 554 "grap.yy"
    { (yyval.num) = ((yyvsp[(1) - (3)].num) || (yyvsp[(3) - (3)].num)); }
    break;

  case 95:

/* Line 1464 of yacc.c  */
#line 556 "grap.yy"
    { (yyval.num) = ! ( (int) (yyvsp[(2) - (2)].num)); }
    break;

  case 96:

/* Line 1464 of yacc.c  */
#line 558 "grap.yy"
    { (yyval.num) = (*(yyvsp[(1) - (3)].String) == *(yyvsp[(3) - (3)].String)); delete (yyvsp[(1) - (3)].String); delete (yyvsp[(3) - (3)].String); }
    break;

  case 97:

/* Line 1464 of yacc.c  */
#line 560 "grap.yy"
    { (yyval.num) = (*(yyvsp[(1) - (3)].String) != *(yyvsp[(3) - (3)].String)); delete (yyvsp[(1) - (3)].String); delete (yyvsp[(3) - (3)].String); }
    break;

  case 98:

/* Line 1464 of yacc.c  */
#line 564 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (2)].num); }
    break;

  case 99:

/* Line 1464 of yacc.c  */
#line 565 "grap.yy"
    { (yyval.num) = (yyvsp[(1) - (1)].num); }
    break;

  case 100:

/* Line 1464 of yacc.c  */
#line 570 "grap.yy"
    { (yyval.num) = assignment_statement((yyvsp[(1) - (2)].String), (yyvsp[(2) - (2)].num));  }
    break;

  case 101:

/* Line 1464 of yacc.c  */
#line 575 "grap.yy"
    { (yyval.pt) = new point((yyvsp[(1) - (3)].num), (yyvsp[(3) - (3)].num), 0); }
    break;

  case 102:

/* Line 1464 of yacc.c  */
#line 577 "grap.yy"
    { (yyval.pt) = new point((yyvsp[(2) - (5)].num), (yyvsp[(4) - (5)].num), 0); }
    break;

  case 103:

/* Line 1464 of yacc.c  */
#line 581 "grap.yy"
    { (yyval.pt) = new point((yyvsp[(2) - (2)].pt)->x, (yyvsp[(2) - (2)].pt)->y, (yyvsp[(1) - (2)].coordptr)); delete (yyvsp[(2) - (2)].pt); }
    break;

  case 104:

/* Line 1464 of yacc.c  */
#line 586 "grap.yy"
    {
	      struct tm tm = { 0 };
	      if (strptime((yyvsp[(5) - (6)].String)->c_str(), (yyvsp[(3) - (6)].String)->c_str(), &tm) != 0) {
	      	  time_t t = mktime(&tm);
	          (yyval.num) = t;
	      }
	      else  {
	      	  cerr << "Could not parse time/date " << *(yyvsp[(5) - (6)].String) 
		       << " using format " << *(yyvsp[(3) - (6)].String) << endl;
	          (yyval.num) = 0.0;
	      }
            }
    break;

  case 105:

/* Line 1464 of yacc.c  */
#line 602 "grap.yy"
    {
		(yyval.stringmod).size = 0;
		(yyval.stringmod).rel =0;
		(yyval.stringmod).just = (unaligned_default) ? unaligned : 0;
		(yyval.stringmod).clip = clip_default;
		(yyval.stringmod).color = 0;
	    }
    break;

  case 106:

/* Line 1464 of yacc.c  */
#line 610 "grap.yy"
    { (yyval.stringmod).size = (yyvsp[(3) - (3)].num); (yyval.stringmod).rel = ((yyvsp[(3) - (3)].num)<0); }
    break;

  case 107:

/* Line 1464 of yacc.c  */
#line 612 "grap.yy"
    { (yyval.stringmod).size = (yyvsp[(4) - (4)].num); (yyval.stringmod).rel = 1; }
    break;

  case 108:

/* Line 1464 of yacc.c  */
#line 614 "grap.yy"
    { (yyval.stringmod).just |= (int) ljust; }
    break;

  case 109:

/* Line 1464 of yacc.c  */
#line 616 "grap.yy"
    { (yyval.stringmod).just |= (int) rjust; }
    break;

  case 110:

/* Line 1464 of yacc.c  */
#line 618 "grap.yy"
    { (yyval.stringmod).just |= (int) above; }
    break;

  case 111:

/* Line 1464 of yacc.c  */
#line 620 "grap.yy"
    { (yyval.stringmod).just |= (int) below; }
    break;

  case 112:

/* Line 1464 of yacc.c  */
#line 622 "grap.yy"
    { (yyval.stringmod).just |= (int) aligned; }
    break;

  case 113:

/* Line 1464 of yacc.c  */
#line 624 "grap.yy"
    { (yyval.stringmod).just |= (int) unaligned; }
    break;

  case 114:

/* Line 1464 of yacc.c  */
#line 626 "grap.yy"
    { (yyval.stringmod).clip = true; }
    break;

  case 115:

/* Line 1464 of yacc.c  */
#line 628 "grap.yy"
    { (yyval.stringmod).clip = false; }
    break;

  case 116:

/* Line 1464 of yacc.c  */
#line 630 "grap.yy"
    { (yyval.stringmod).color = (yyvsp[(3) - (3)].String); }
    break;

  case 117:

/* Line 1464 of yacc.c  */
#line 635 "grap.yy"
    {
		DisplayString *s;

		s = new DisplayString(*(yyvsp[(1) - (2)].String),(yyvsp[(2) - (2)].stringmod).just,(yyvsp[(2) - (2)].stringmod).size, (yyvsp[(2) - (2)].stringmod).rel, 
		    (yyvsp[(2) - (2)].stringmod).clip, (yyvsp[(2) - (2)].stringmod).color);
		delete (yyvsp[(1) - (2)].String);
		(yyval.string_list) = new stringlist;
		(yyval.string_list)->push_back(s);
	    }
    break;

  case 118:

/* Line 1464 of yacc.c  */
#line 645 "grap.yy"
    { (yyval.string_list) = combine_strings((yyvsp[(1) - (3)].string_list), (yyvsp[(2) - (3)].String), (yyvsp[(3) - (3)].stringmod)); }
    break;

  case 119:

/* Line 1464 of yacc.c  */
#line 650 "grap.yy"
    {
  		the_graph->new_plot((yyvsp[(1) - (4)].string_list),(yyvsp[(3) - (4)].pt));
	    }
    break;

  case 120:

/* Line 1464 of yacc.c  */
#line 654 "grap.yy"
    { plot_statement((yyvsp[(2) - (6)].num), (yyvsp[(3) - (6)].ds), (yyvsp[(5) - (6)].pt)); }
    break;

  case 121:

/* Line 1464 of yacc.c  */
#line 659 "grap.yy"
    { next_statement((yyvsp[(2) - (6)].String), (yyvsp[(4) - (6)].pt), (yyvsp[(5) - (6)].lined)); }
    break;

  case 122:

/* Line 1464 of yacc.c  */
#line 664 "grap.yy"
    {
		(yyval.frameptr) = new frame;
		(yyval.frameptr)->ht = (yyvsp[(2) - (2)].num);
		(yyval.frameptr)->wid = 0;
	    }
    break;

  case 123:

/* Line 1464 of yacc.c  */
#line 670 "grap.yy"
    {
		(yyval.frameptr) = new frame;
		(yyval.frameptr)->wid = (yyvsp[(2) - (2)].num);
		(yyval.frameptr)->ht = 0;
	    }
    break;

  case 124:

/* Line 1464 of yacc.c  */
#line 679 "grap.yy"
    { (yyval.frameptr) = (yyvsp[(1) - (1)].frameptr); }
    break;

  case 125:

/* Line 1464 of yacc.c  */
#line 681 "grap.yy"
    {
		(yyval.frameptr) = (yyvsp[(1) - (2)].frameptr);
		// Fill in non-default ht/wid
		
		if ( (yyvsp[(2) - (2)].frameptr)->ht != 0 ) (yyval.frameptr)->ht = (yyvsp[(2) - (2)].frameptr)->ht;
		if ( (yyvsp[(2) - (2)].frameptr)->wid != 0 ) (yyval.frameptr)->wid = (yyvsp[(2) - (2)].frameptr)->wid;
	    }
    break;

  case 126:

/* Line 1464 of yacc.c  */
#line 692 "grap.yy"
    { (yyval.side) = top_side;}
    break;

  case 127:

/* Line 1464 of yacc.c  */
#line 694 "grap.yy"
    { (yyval.side)= bottom_side;}
    break;

  case 128:

/* Line 1464 of yacc.c  */
#line 696 "grap.yy"
    { (yyval.side) = left_side;}
    break;

  case 129:

/* Line 1464 of yacc.c  */
#line 698 "grap.yy"
    { (yyval.side) = right_side; }
    break;

  case 130:

/* Line 1464 of yacc.c  */
#line 703 "grap.yy"
    {
		// This rule combines the explicit size settings with
		// the defaults. We create a new frame to have access
		// to the default sizes without needing to code them
		// explicitly (they're always implicit in a default
		// frame). N. B. that frames created by size (and
		// size_elem) use 0 to indicate no change to the ht or
		// wid.
		
		(yyval.frameptr) = new frame;

		if ( (yyvsp[(1) - (1)].frameptr)->ht != 0) (yyval.frameptr)->ht = (yyvsp[(1) - (1)].frameptr)->ht;
		if ( (yyvsp[(1) - (1)].frameptr)->wid != 0) (yyval.frameptr)->wid = (yyvsp[(1) - (1)].frameptr)->wid;
		delete (yyvsp[(1) - (1)].frameptr);
	    }
    break;

  case 131:

/* Line 1464 of yacc.c  */
#line 720 "grap.yy"
    {
		(yyval.frameptr) = new frame;
		(yyval.frameptr)->desc[(yyvsp[(1) - (2)].side)] = *(yyvsp[(2) - (2)].lined);
		delete (yyvsp[(2) - (2)].lined);
	    }
    break;

  case 132:

/* Line 1464 of yacc.c  */
#line 726 "grap.yy"
    {
		if ( !(yyvsp[(1) - (3)].frameptr) ) (yyval.frameptr) = new frame;
		else (yyval.frameptr) = (yyvsp[(1) - (3)].frameptr);
		
		(yyval.frameptr)->desc[(yyvsp[(2) - (3)].side)] = *(yyvsp[(3) - (3)].lined);
		delete (yyvsp[(3) - (3)].lined);
	    }
    break;

  case 133:

/* Line 1464 of yacc.c  */
#line 752 "grap.yy"
    { process_frame(0, 0, 0); }
    break;

  case 134:

/* Line 1464 of yacc.c  */
#line 754 "grap.yy"
    { process_frame((yyvsp[(2) - (3)].lined), 0, 0); }
    break;

  case 135:

/* Line 1464 of yacc.c  */
#line 756 "grap.yy"
    { process_frame(0, (yyvsp[(2) - (3)].frameptr), 0); }
    break;

  case 136:

/* Line 1464 of yacc.c  */
#line 758 "grap.yy"
    { process_frame(0, 0, (yyvsp[(2) - (3)].frameptr)); }
    break;

  case 137:

/* Line 1464 of yacc.c  */
#line 760 "grap.yy"
    { process_frame(0, (yyvsp[(2) - (4)].frameptr), (yyvsp[(3) - (4)].frameptr)); }
    break;

  case 138:

/* Line 1464 of yacc.c  */
#line 762 "grap.yy"
    { process_frame((yyvsp[(2) - (4)].lined), 0, (yyvsp[(3) - (4)].frameptr)); }
    break;

  case 139:

/* Line 1464 of yacc.c  */
#line 764 "grap.yy"
    { process_frame((yyvsp[(2) - (4)].lined), (yyvsp[(3) - (4)].frameptr), 0); }
    break;

  case 140:

/* Line 1464 of yacc.c  */
#line 766 "grap.yy"
    { process_frame((yyvsp[(3) - (4)].lined), (yyvsp[(2) - (4)].frameptr), 0); }
    break;

  case 141:

/* Line 1464 of yacc.c  */
#line 768 "grap.yy"
    { process_frame((yyvsp[(2) - (5)].lined), (yyvsp[(3) - (5)].frameptr), (yyvsp[(4) - (5)].frameptr));}
    break;

  case 142:

/* Line 1464 of yacc.c  */
#line 770 "grap.yy"
    { process_frame((yyvsp[(3) - (5)].lined), (yyvsp[(2) - (5)].frameptr), (yyvsp[(4) - (5)].frameptr)); }
    break;

  case 143:

/* Line 1464 of yacc.c  */
#line 775 "grap.yy"
    { (yyval.shift) = new shiftdesc(top_side, (yyvsp[(2) - (2)].num)); }
    break;

  case 144:

/* Line 1464 of yacc.c  */
#line 777 "grap.yy"
    { (yyval.shift) = new shiftdesc(bottom_side, (yyvsp[(2) - (2)].num)); }
    break;

  case 145:

/* Line 1464 of yacc.c  */
#line 779 "grap.yy"
    { (yyval.shift) = new shiftdesc(left_side, (yyvsp[(2) - (2)].num)); }
    break;

  case 146:

/* Line 1464 of yacc.c  */
#line 781 "grap.yy"
    { (yyval.shift) = new shiftdesc(right_side, (yyvsp[(2) - (2)].num)); }
    break;

  case 147:

/* Line 1464 of yacc.c  */
#line 786 "grap.yy"
    { (yyval.val) = -1; }
    break;

  case 148:

/* Line 1464 of yacc.c  */
#line 788 "grap.yy"
    { (yyval.val) = 1; }
    break;

  case 149:

/* Line 1464 of yacc.c  */
#line 792 "grap.yy"
    { (yyval.num) = 0.125; }
    break;

  case 150:

/* Line 1464 of yacc.c  */
#line 794 "grap.yy"
    {
		if ( (yyvsp[(2) - (2)].num) == 0 ) (yyval.num) = (yyvsp[(1) - (2)].val) * 0.125;
		else (yyval.num) = (yyvsp[(1) - (2)].val) * (yyvsp[(2) - (2)].num);
	    }
    break;

  case 151:

/* Line 1464 of yacc.c  */
#line 802 "grap.yy"
    { (yyval.tick_list) = ticklist_elem((yyvsp[(1) - (2)].num), (yyvsp[(2) - (2)].ds), 0); }
    break;

  case 152:

/* Line 1464 of yacc.c  */
#line 804 "grap.yy"
    { (yyval.tick_list) = ticklist_elem((yyvsp[(3) - (4)].num), (yyvsp[(4) - (4)].ds), (yyvsp[(1) - (4)].tick_list)); }
    break;

  case 153:

/* Line 1464 of yacc.c  */
#line 808 "grap.yy"
    { (yyval.by).op = PLUS; (yyval.by).expr = 1; }
    break;

  case 154:

/* Line 1464 of yacc.c  */
#line 810 "grap.yy"
    {
		(yyval.by).op = PLUS;
		if ( (yyvsp[(2) - (2)].num) != 0.0 ) (yyval.by).expr = (yyvsp[(2) - (2)].num);
		else (yyval.by).expr = 1;
	    }
    break;

  case 155:

/* Line 1464 of yacc.c  */
#line 816 "grap.yy"
    { (yyval.by).op = PLUS; (yyval.by).expr = (yyvsp[(3) - (3)].num); }
    break;

  case 156:

/* Line 1464 of yacc.c  */
#line 818 "grap.yy"
    { (yyval.by).op = TIMES; (yyval.by).expr = (yyvsp[(3) - (3)].num); }
    break;

  case 157:

/* Line 1464 of yacc.c  */
#line 820 "grap.yy"
    { (yyval.by).op = DIV; (yyval.by).expr = (yyvsp[(3) - (3)].num); }
    break;

  case 158:

/* Line 1464 of yacc.c  */
#line 822 "grap.yy"
    { (yyval.by).op = MOD; (yyval.by).expr = (yyvsp[(3) - (3)].num); }
    break;

  case 159:

/* Line 1464 of yacc.c  */
#line 827 "grap.yy"
    {
		(yyval.tick_list) = (yyvsp[(3) - (3)].tick_list);
		for (ticklist::iterator t= (yyvsp[(3) - (3)].tick_list)->begin(); t != (yyvsp[(3) - (3)].tick_list)->end(); t++)
		    (*t)->c = (yyvsp[(2) - (3)].coordptr);
	    }
    break;

  case 160:

/* Line 1464 of yacc.c  */
#line 836 "grap.yy"
    { (yyval.tick_list) = tick_for((yyvsp[(2) - (7)].coordptr), (yyvsp[(3) - (7)].num), (yyvsp[(5) - (7)].num), (yyvsp[(6) - (7)].by), (yyvsp[(7) - (7)].ds)); }
    break;

  case 161:

/* Line 1464 of yacc.c  */
#line 840 "grap.yy"
    { (yyval.tick_list) = (yyvsp[(1) - (1)].tick_list);}
    break;

  case 162:

/* Line 1464 of yacc.c  */
#line 842 "grap.yy"
    { (yyval.tick_list)= (yyvsp[(1) - (1)].tick_list); }
    break;

  case 163:

/* Line 1464 of yacc.c  */
#line 847 "grap.yy"
    {
		coordinateDictionary::iterator ci;

		if ( (yyvsp[(2) - (2)].String) ) {
		    ci = the_graph->coords.find(*(yyvsp[(2) - (2)].String));
		    if ( ci != the_graph->coords.end()) 
			(yyval.coordptr) = (*ci).second;
		    else {
			yyerror("Name must name a coordinate space");
		    }
		}
		else (yyval.coordptr) = 0;
		
	    }
    break;

  case 164:

/* Line 1464 of yacc.c  */
#line 862 "grap.yy"
    {
		(yyval.coordptr) = 0;
            }
    break;

  case 165:

/* Line 1464 of yacc.c  */
#line 869 "grap.yy"
    { ticks_statement((yyvsp[(2) - (6)].side), (yyvsp[(3) - (6)].num), (yyvsp[(4) - (6)].shift_list), (yyvsp[(5) - (6)].tick_list)); }
    break;

  case 166:

/* Line 1464 of yacc.c  */
#line 871 "grap.yy"
    {
		for ( int i = 0; i< 4; i++ )
		    the_graph->base->tickdef[i].size = 0;
	    }
    break;

  case 167:

/* Line 1464 of yacc.c  */
#line 876 "grap.yy"
    { the_graph->base->tickdef[(yyvsp[(2) - (4)].side)].size = 0; }
    break;

  case 168:

/* Line 1464 of yacc.c  */
#line 878 "grap.yy"
    {
		the_graph->base->tickdef[(yyvsp[(2) - (5)].side)].size = (yyvsp[(3) - (5)].num);
		if ( (yyvsp[(4) - (5)].coordptr) ) the_graph->base->tickdef[(yyvsp[(2) - (5)].side)].c = (yyvsp[(4) - (5)].coordptr);
	    }
    break;

  case 169:

/* Line 1464 of yacc.c  */
#line 885 "grap.yy"
    { (yyval.val) = 0; }
    break;

  case 170:

/* Line 1464 of yacc.c  */
#line 887 "grap.yy"
    { (yyval.val) = 1; }
    break;

  case 171:

/* Line 1464 of yacc.c  */
#line 892 "grap.yy"
    {
		grid_statement((yyvsp[(2) - (7)].side), (yyvsp[(3) - (7)].val), (yyvsp[(4) - (7)].lined), (yyvsp[(5) - (7)].shift_list), (yyvsp[(6) - (7)].tick_list));
	    }
    break;

  case 172:

/* Line 1464 of yacc.c  */
#line 896 "grap.yy"
    {
		grid_statement((yyvsp[(2) - (7)].side), (yyvsp[(3) - (7)].val), (yyvsp[(4) - (7)].lined), (yyvsp[(5) - (7)].shift_list), 0);
		// Because turning on a grid on a given side disables
		// automatic tick generation there, this is sets up
		// that side with the proper coordinates.
		if ( (yyvsp[(6) - (7)].coordptr) ) the_graph->base->griddef[(yyvsp[(2) - (7)].side)].c = (yyvsp[(6) - (7)].coordptr);
	    }
    break;

  case 173:

/* Line 1464 of yacc.c  */
#line 907 "grap.yy"
    {
		shiftdesc *sd;

		for (stringlist::iterator s = (yyvsp[(3) - (5)].string_list)->begin(); s != (yyvsp[(3) - (5)].string_list)->end(); s++)
		    if ( ! ((*s)->j & unaligned) ) (*s)->j |= aligned;
		
		the_graph->base->label[(yyvsp[(2) - (5)].side)] = (yyvsp[(3) - (5)].string_list);

		// Copy the label shifts into the frame
		while (!(yyvsp[(4) - (5)].shift_list)->empty() ) {
		    sd = (yyvsp[(4) - (5)].shift_list)->front();
		    (yyvsp[(4) - (5)].shift_list)->pop_front();
		    the_graph->base->lshift[(yyvsp[(2) - (5)].side)]->push_back(sd);
		}
		delete (yyvsp[(4) - (5)].shift_list);
	    }
    break;

  case 174:

/* Line 1464 of yacc.c  */
#line 925 "grap.yy"
    { (yyval.num) = 0.025; }
    break;

  case 175:

/* Line 1464 of yacc.c  */
#line 927 "grap.yy"
    { (yyval.num) = (yyvsp[(2) - (2)].num); }
    break;

  case 176:

/* Line 1464 of yacc.c  */
#line 932 "grap.yy"
    {
		the_graph->new_circle((yyvsp[(3) - (6)].pt),(yyvsp[(4) - (6)].num),(yyvsp[(5) - (6)].lined));
		delete (yyvsp[(3) - (6)].pt); delete (yyvsp[(5) - (6)].lined);
	    }
    break;

  case 177:

/* Line 1464 of yacc.c  */
#line 940 "grap.yy"
    { (yyval.val) = 1; }
    break;

  case 178:

/* Line 1464 of yacc.c  */
#line 942 "grap.yy"
    { (yyval.val) = 0; }
    break;

  case 179:

/* Line 1464 of yacc.c  */
#line 947 "grap.yy"
    { line_statement((yyvsp[(1) - (8)].val), (yyvsp[(2) - (8)].lined), (yyvsp[(4) - (8)].pt), (yyvsp[(6) - (8)].pt), (yyvsp[(7) - (8)].lined)); }
    break;

  case 180:

/* Line 1464 of yacc.c  */
#line 951 "grap.yy"
    { (yyval.axistype).which=none; }
    break;

  case 181:

/* Line 1464 of yacc.c  */
#line 953 "grap.yy"
    { (yyval.axistype) = axis_description(x_axis, (yyvsp[(2) - (4)].num), (yyvsp[(4) - (4)].num)); }
    break;

  case 182:

/* Line 1464 of yacc.c  */
#line 956 "grap.yy"
    { (yyval.axistype).which=none; }
    break;

  case 183:

/* Line 1464 of yacc.c  */
#line 958 "grap.yy"
    { (yyval.axistype) = axis_description(y_axis, (yyvsp[(2) - (4)].num), (yyvsp[(4) - (4)].num)); }
    break;

  case 184:

/* Line 1464 of yacc.c  */
#line 963 "grap.yy"
    { (yyval.axisname) = combine_logs((yyvsp[(1) - (2)].axisname), (yyvsp[(2) - (2)].axisname)); }
    break;

  case 185:

/* Line 1464 of yacc.c  */
#line 965 "grap.yy"
    { (yyval.axisname) = none; }
    break;

  case 186:

/* Line 1464 of yacc.c  */
#line 970 "grap.yy"
    { (yyval.axisname) = x_axis; }
    break;

  case 187:

/* Line 1464 of yacc.c  */
#line 972 "grap.yy"
    { (yyval.axisname) = y_axis; }
    break;

  case 188:

/* Line 1464 of yacc.c  */
#line 974 "grap.yy"
    { (yyval.axisname) = both; }
    break;

  case 189:

/* Line 1464 of yacc.c  */
#line 980 "grap.yy"
    {
		coord_statement((yyvsp[(2) - (6)].String), (yyvsp[(3) - (6)].axistype), (yyvsp[(4) - (6)].axistype), (yyvsp[(5) - (6)].axisname));
		delete (yyvsp[(2) - (6)].String);
	    }
    break;

  case 190:

/* Line 1464 of yacc.c  */
#line 987 "grap.yy"
    { (yyval.copyd) = 0; }
    break;

  case 191:

/* Line 1464 of yacc.c  */
#line 989 "grap.yy"
    {
		unquote((yyvsp[(2) - (2)].String));
		(yyval.copyd) = new copydesc;
		(yyval.copyd)->t = copydesc::until;
		(yyval.copyd)->s = (yyvsp[(2) - (2)].String);
	    }
    break;

  case 192:

/* Line 1464 of yacc.c  */
#line 996 "grap.yy"
    {
		unquote((yyvsp[(1) - (1)].String));
		(yyval.copyd) = new copydesc;
		(yyval.copyd)->t = copydesc::fname;
		(yyval.copyd)->s = (yyvsp[(1) - (1)].String);
	    }
    break;

  case 193:

/* Line 1464 of yacc.c  */
#line 1011 "grap.yy"
    {
		unquote((yyvsp[(2) - (3)].String));
		if (!include_file((yyvsp[(2) - (3)].String), false)) return 0;
	    }
    break;

  case 194:

/* Line 1464 of yacc.c  */
#line 1016 "grap.yy"
    {
		unquote((yyvsp[(3) - (4)].String));
		lex_begin_copy((yyvsp[(3) - (4)].String));
	    }
    break;

  case 195:

/* Line 1464 of yacc.c  */
#line 1021 "grap.yy"
    {
		string s="";
		while ((yyvsp[(6) - (6)].line_list) && !(yyvsp[(6) - (6)].line_list)->empty() ) {
		    string *ss;
		    ss = (yyvsp[(6) - (6)].line_list)->front();
		    (yyvsp[(6) - (6)].line_list)->pop_front();
		    if ( ss ) {
			s+= *ss;
			s+= '\n';
			delete ss;
			ss = 0;
		    }
		}
		include_string(&s, 0, GINTERNAL);
		delete (yyvsp[(6) - (6)].line_list);
	    }
    break;

  case 196:

/* Line 1464 of yacc.c  */
#line 1037 "grap.yy"
    { lex_hunt_macro(); }
    break;

  case 197:

/* Line 1464 of yacc.c  */
#line 1038 "grap.yy"
    {
		copydesc *c = 0; // To shut the compiler up about uninit
		if ( (yyvsp[(2) - (7)].copyd) && (yyvsp[(6) - (7)].copyd) ) {
		    delete (yyvsp[(2) - (7)].copyd);
		    delete (yyvsp[(6) - (7)].copyd);
		    yyerror("Only specify 1 until or filename\n");
		}
		else c = ((yyvsp[(2) - (7)].copyd)) ? (yyvsp[(2) - (7)].copyd) : (yyvsp[(6) - (7)].copyd);
		// The else handles files with neither else clause, copying
		// text to the trailing .G2.  Fix from Bruce Lilly
		if ( c ) {
		    // lex_begin_copy takes command of the string that's
		    // passed to it, so don't delete it.  (I don't
		    // remember why I did that...)
		    if ( c->t == copydesc::until ) {
			lex_begin_copy(c->s);
			c->s = 0;
		    }
		    else {
			lex_begin_copy(0);
			include_file(c->s, false);
		    }
		    delete c;
		}
		else lex_begin_copy(0);
	    }
    break;

  case 198:

/* Line 1464 of yacc.c  */
#line 1065 "grap.yy"
    {
		string *s;
		string *t;
		int lim;
		char end;
		stack<string *> st;

		while ( (yyvsp[(9) - (9)].line_list) && !(yyvsp[(9) - (9)].line_list)->empty() ) {
		    int i = 0;
		    t = new string;
		    
		    s = (yyvsp[(9) - (9)].line_list)->front();
		    (yyvsp[(9) - (9)].line_list)->pop_front();
		    lim = s->length();
		    
		    while ( i < lim ) {
			if ( (*s)[i] == ' ' || (*s)[i] == '\t' ) {
			    if ( t->length() ) {
				if ( (yyvsp[(5) - (9)].macro_val)->add_arg(t)) 
				    t = new string;
			    }
			} else *t += (*s)[i];
			i++;
		    }
		    if ( t->length() ) (yyvsp[(5) - (9)].macro_val)->add_arg(t);
		    else if (t) delete t;
		    t = (yyvsp[(5) - (9)].macro_val)->invoke();
		    // "here" macros should end with a SEP.  If the
		    // user hasn't done so, we add a SEP for them.
		    // Even named macros should get a sep when they're
		    // copied through,

		    end = (*t)[t->length()-1];

		    if ( end != ';' && end != '\n' ) 
			*t += ';';
		    // Because include string stacks the strings, we stack them
		    // here and call include_string in reverse order to ensure
		    // correct ordered execution of multiple lines.
		    st.push(t);
		    delete s;
		}
		delete (yyvsp[(9) - (9)].line_list);
		while ( !st.empty() ) {
		    include_string(st.top(), 0, GMACRO);
		    delete st.top();
		    st.pop();
	        }
		// don't delete defined macros
		if ( !(yyvsp[(5) - (9)].macro_val)->name)
		    delete (yyvsp[(5) - (9)].macro_val);
	    }
    break;

  case 199:

/* Line 1464 of yacc.c  */
#line 1120 "grap.yy"
    { lex_no_coord(); lex_no_macro_expansion();}
    break;

  case 200:

/* Line 1464 of yacc.c  */
#line 1121 "grap.yy"
    { lex_begin_macro_text(); }
    break;

  case 201:

/* Line 1464 of yacc.c  */
#line 1122 "grap.yy"
    { lex_macro_expansion_ok(); lex_coord_ok(); define_macro((yyvsp[(3) - (6)].String), (yyvsp[(5) - (6)].String)); }
    break;

  case 202:

/* Line 1464 of yacc.c  */
#line 1126 "grap.yy"
    { lex_no_coord(); lex_no_macro_expansion(); }
    break;

  case 203:

/* Line 1464 of yacc.c  */
#line 1126 "grap.yy"
    {
	    lex_coord_ok();
	    lex_macro_expansion_ok();
	    macros.erase(*(yyvsp[(3) - (4)].String));
	    delete (yyvsp[(3) - (4)].String);
	}
    break;

  case 204:

/* Line 1464 of yacc.c  */
#line 1134 "grap.yy"
    { lex_begin_macro_text(); }
    break;

  case 205:

/* Line 1464 of yacc.c  */
#line 1135 "grap.yy"
    {
		int len = (yyvsp[(3) - (4)].String)->length()+1 ;
		char *sys = new char [len];
		int i=0;
		int srv = 0;

		// String to char*
		       
		while ((sys[i] = (*(yyvsp[(3) - (4)].String))[i]))
		    i++;

		delete (yyvsp[(3) - (4)].String);
		
		if ( (srv = system(sys)) )
		    cerr << "Warn: system returned " << srv << endl;
	    }
    break;

  case 206:

/* Line 1464 of yacc.c  */
#line 1154 "grap.yy"
    { (yyval.String) = 0; }
    break;

  case 207:

/* Line 1464 of yacc.c  */
#line 1155 "grap.yy"
    {lex_begin_macro_text(); }
    break;

  case 208:

/* Line 1464 of yacc.c  */
#line 1156 "grap.yy"
    {
		// force else clause to end with a SEP
		*(yyvsp[(3) - (3)].String)+= ';';
		(yyval.String) = (yyvsp[(3) - (3)].String);
	    }
    break;

  case 209:

/* Line 1464 of yacc.c  */
#line 1164 "grap.yy"
    { lex_begin_macro_text(); }
    break;

  case 210:

/* Line 1464 of yacc.c  */
#line 1165 "grap.yy"
    {
		// force all if blocks to be terminated by a SEP.  
		*(yyvsp[(5) - (7)].String) += ';';
		// We use epsilon in loop tests 
		if ( fabs((yyvsp[(2) - (7)].num)) > epsilon ) include_string((yyvsp[(5) - (7)].String),0,GINTERNAL);
		else if ( (yyvsp[(6) - (7)].String) ) include_string((yyvsp[(6) - (7)].String),0,GINTERNAL);
		delete (yyvsp[(5) - (7)].String);
		delete (yyvsp[(6) - (7)].String);
	    }
    break;

  case 211:

/* Line 1464 of yacc.c  */
#line 1178 "grap.yy"
    { lex_begin_macro_text(); }
    break;

  case 212:

/* Line 1464 of yacc.c  */
#line 1179 "grap.yy"
    { 
		for_statement((yyvsp[(2) - (11)].String), (yyvsp[(4) - (11)].num), (yyvsp[(6) - (11)].num), (yyvsp[(7) - (11)].by), (yyvsp[(10) - (11)].String));
		delete (yyvsp[(2) - (11)].String);
	    }
    break;

  case 213:

/* Line 1464 of yacc.c  */
#line 1186 "grap.yy"
    { lex_no_coord(); }
    break;

  case 214:

/* Line 1464 of yacc.c  */
#line 1186 "grap.yy"
    { lex_begin_rest_of_line(); }
    break;

  case 215:

/* Line 1464 of yacc.c  */
#line 1187 "grap.yy"
    {
		if ( !first_line ) {
		    // Only draw the graph and clear its internals if
		    // it is visible.  This allows a user to declare
		    // things like coordinate spaces before the graph
		    // itself is named.  This is a compatibility
		    // feature for DWB grap.
		    if ( the_graph->is_visible() ) {
			the_graph->draw(0);
			the_graph->init((yyvsp[(3) - (6)].String), (yyvsp[(5) - (6)].String));
			init_dict();
		    }
		    else
			the_graph->setname((yyvsp[(3) - (6)].String));
		}
		else {
		    the_graph->init((yyvsp[(3) - (6)].String), (yyvsp[(5) - (6)].String));
		    init_dict();
		}
		    
		if ( (yyvsp[(3) - (6)].String) ) delete (yyvsp[(3) - (6)].String);
		if ( (yyvsp[(5) - (6)].String) ) delete (yyvsp[(5) - (6)].String);
	    }
    break;

  case 217:

/* Line 1464 of yacc.c  */
#line 1218 "grap.yy"
    {
		unquote((yyvsp[(1) - (1)].String));
		cerr <<  *(yyvsp[(1) - (1)].String) << endl;
	    }
    break;

  case 218:

/* Line 1464 of yacc.c  */
#line 1223 "grap.yy"
    {
		cerr << (yyvsp[(1) - (1)].num) << endl;
	    }
    break;

  case 219:

/* Line 1464 of yacc.c  */
#line 1229 "grap.yy"
    { lex_begin_rest_of_line(); }
    break;

  case 220:

/* Line 1464 of yacc.c  */
#line 1230 "grap.yy"
    { the_graph->passthru_string(*(yyvsp[(3) - (4)].String)); delete (yyvsp[(3) - (4)].String);}
    break;

  case 221:

/* Line 1464 of yacc.c  */
#line 1234 "grap.yy"
    { the_graph->passthru_string(*(yyvsp[(1) - (2)].String)); delete (yyvsp[(1) - (2)].String);}
    break;

  case 222:

/* Line 1464 of yacc.c  */
#line 1239 "grap.yy"
    { (yyval.side) = right_side; }
    break;

  case 223:

/* Line 1464 of yacc.c  */
#line 1241 "grap.yy"
    { (yyval.side) = top_side; }
    break;

  case 224:

/* Line 1464 of yacc.c  */
#line 1247 "grap.yy"
    { (yyval.bar_p) = new bar_param; (yyval.bar_p)->ht = (yyvsp[(2) - (2)].num); (yyval.bar_p)->have_ht = true; }
    break;

  case 225:

/* Line 1464 of yacc.c  */
#line 1248 "grap.yy"
    { (yyval.bar_p) = new bar_param; (yyval.bar_p)->wid = (yyvsp[(2) - (2)].num); }
    break;

  case 226:

/* Line 1464 of yacc.c  */
#line 1249 "grap.yy"
    { (yyval.bar_p) = new bar_param; (yyval.bar_p)->base = (yyvsp[(2) - (2)].num); }
    break;

  case 227:

/* Line 1464 of yacc.c  */
#line 1253 "grap.yy"
    { (yyval.bar_p) = (yyvsp[(1) - (1)].bar_p); }
    break;

  case 228:

/* Line 1464 of yacc.c  */
#line 1254 "grap.yy"
    { 
		(yyval.bar_p) = (yyvsp[(1) - (2)].bar_p);
		if ( (yyvsp[(2) - (2)].bar_p) ) {
			if ((yyvsp[(2) - (2)].bar_p)->have_x ) { (yyval.bar_p)->x = (yyvsp[(2) - (2)].bar_p)->x; (yyval.bar_p)->have_x = true; }
			if ((yyvsp[(2) - (2)].bar_p)->have_ht ) { 
				(yyval.bar_p)->ht = (yyvsp[(2) - (2)].bar_p)->ht; (yyval.bar_p)->have_ht = true;
			}
			if ( (yyvsp[(2) - (2)].bar_p)->wid != 1.0 ) { (yyval.bar_p)->wid = (yyvsp[(2) - (2)].bar_p)->wid; }
			if ( (yyvsp[(2) - (2)].bar_p)->base != 0.0 ) { (yyval.bar_p)->base = (yyvsp[(2) - (2)].bar_p)->base; }
			delete (yyvsp[(2) - (2)].bar_p);
		}
	}
    break;

  case 229:

/* Line 1464 of yacc.c  */
#line 1270 "grap.yy"
    {
		// The point parsing has already autoscaled the
		// coordinate system to include those points.
		the_graph->new_box((yyvsp[(2) - (6)].pt), (yyvsp[(4) - (6)].pt), (yyvsp[(5) - (6)].lined));
		delete (yyvsp[(2) - (6)].pt); delete (yyvsp[(4) - (6)].pt); delete (yyvsp[(5) - (6)].lined);
	    }
    break;

  case 230:

/* Line 1464 of yacc.c  */
#line 1277 "grap.yy"
    { 
	   	if ( !(yyvsp[(5) - (7)].bar_p) || !(yyvsp[(5) - (7)].bar_p)->have_ht ) {
			yyerror("bar must have a position and ht ");
		}
		else {
			bar_statement((yyvsp[(3) - (7)].coordptr), (yyvsp[(2) - (7)].side), (yyvsp[(4) - (7)].num), (yyvsp[(5) - (7)].bar_p)->ht, (yyvsp[(5) - (7)].bar_p)->wid, 
				(yyvsp[(5) - (7)].bar_p)->base, (yyvsp[(6) - (7)].lined));
		}
		delete (yyvsp[(5) - (7)].bar_p);
	}
    break;

  case 231:

/* Line 1464 of yacc.c  */
#line 1291 "grap.yy"
    { if ( (yyvsp[(1) - (4)].val) >=0 && (yyvsp[(1) - (4)].val) < NVF1 ) jtvf1[(yyvsp[(1) - (4)].val)]((yyvsp[(3) - (4)].num)); }
    break;



/* Line 1464 of yacc.c  */
#line 4214 "grap.cc"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1684 of yacc.c  */
#line 1293 "grap.yy"


#ifdef __MINGW32__
// From http://stackoverflow.com/questions/321849/strptime-equivalent-on-windows#3137634
// Note: This needs GCC 5.1 or later to work.
#include <time.h>
#include <iomanip>
#include <sstream>

char * strptime(const char* str, const char* fmt, struct tm* tm) {
  //  C++ standard std::get_time is defined such that its format
  //  parameters are the exact same as strptime.
  std::istringstream input(str);
  input.imbue(std::locale(""));
  input >> std::get_time(tm, fmt);
  if (input.fail()) {
    return nullptr;
  }
  return (char*)(str + input.tellg());
}
#endif

